<?php

// debug.class.php
// -------------------------------------------------------------------------------------------------
// Provides a consistent debugging interface for all other classes
// for onscreen debugging
//
// Project    > dmABS
// Copyright  > (C) Digital Mail Limited (2005-2010)
// Author     > RAK for DML
// -------------------------------------------------------------------------------------------------

class Debug
{

	var $debug;			 // Controls whether debugging is on or off
	var $debug_msg;		 // Holds debugging messages
	var $max_width;		 // Maximum number of characters in a line in debugging output
	
	// ---------------------------------------------------------------------------------------------

	function Debug($status = FALSE)
	{
		// CONSTRUCTOR
		$this->debug  	 = $status;
		$this->debug_msg = array();
		$this->max_width = 150;
	}
	
	// ---------------------------------------------------------------------------------------------
	// ---------------------------------------------------------------------------------------------
	// ---------------------------------------------------------------------------------------------

	function heading($msg = '')
	{
		if (!$this->debug) return;
		$this->debug_msg[] = '<h2 class="debug">' . wordwrap($msg, $this->max_width, "<br/>\n", 1) . '</h2>';
	}

	// ---------------------------------------------------------------------------------------------

	function msg($msg = '')
	{
		if (!$this->debug) return;
		if (is_array($msg))
		{	
			$this->debug_msg = array_merge($this->debug_msg, $msg);
		}
		else
		{
			$this->debug_msg[] = wordwrap($msg, $this->max_width, "<br/>\n", 1);
		}
	}

	// ---------------------------------------------------------------------------------------------

	function inspect($name, $var)
	{
		if (!$this->debug) return;
		$this->debug_msg[] = "<b>" . $name . '</b><pre>' . print_r($var, 1) . '</pre>';
	}

	// ---------------------------------------------------------------------------------------------

	function divide()
	{
		if (!$this->debug) return;
		$this->debug_msg[] = '<hr class="debug" />';
	}

	// ---------------------------------------------------------------------------------------------
	// ---------------------------------------------------------------------------------------------
	// ---------------------------------------------------------------------------------------------

	function get()
	{
		return($this->debug_msg);
	}

	// ---------------------------------------------------------------------------------------------

	function flush()
	{
		$temp = $this->debug_msg;
		$this->debug_msg = array();
		return($temp);
	}

	// ---------------------------------------------------------------------------------------------

	function display($flag = FALSE)
	{
		$s = array('</h2><br/>', '<hr class="debug" /><br/>');
		$r = array('</h2>',      '<hr class="debug" />'     );
		if ($flag)
		{
			return(str_replace($s, $r, implode("<br/>\n", $this->debug_msg)));
		}
		else
		{
			echo(str_replace($s, $r, implode("<br/>\n", $this->debug_msg)));
		}
	}

	// ---------------------------------------------------------------------------------------------

}

?>