<?php
function redirect_to($location = NULL)
	{
		if($location != NULL)
		{
			header("Location: {$location}");
			exit;
		}
	}
	
function strip_zeros_from_data($marked_string="")
	{
		// first remove the marked zeros
		$no_zeros = str_replace('*0', '', $marked_string);
		// then remove any remaining marks
		$cleaned_string = str_replace('*', '', $no_zeros);
		return $cleaned_string;
	}
	
function output_message($message="")
	{
		if (!empty($message))
		{
			return "<p class=\"message\">{$message}</p>";
		} else
		{
			return "";
		}
	}

function __autoload($class_name)
{
		$class_name = strtolower($class_name);
		$path = LIB_PATH.DS."{$class_name}.php";
		if(file_exists($path))
		{
			require_once($path);
		} else
		{
			die("The file {$class_name}.php could not be found.");
		}
}


function datetime_to_text($datetime="")
{
	$unixdatetime = strtotime($datetime);
	return strftime("%B %d, %Y at %I:%M %p", $unixdatetime);
}

function include_layout($file="")
{
	include(SITE_ROOT.DS.'events-planning-amsterdam-layouts'.DS.$file);
}

?>