<?php require_once('../gourmet-market-cape-town-includes/market-cape-town-requirements.php');  ?>
<?php 	
	if(!$session->is_logged_in()) {redirect_to("/login.php");} 
	if(!isset($_GET['id']))
	{
		$session->message('<p class="red">No recipe was selected.</p>');
		redirect_to('edit-recipes.php');
	}
	
	$id = trim($_GET['id']);
	$recipe = Recipe::find_by_id($id);
	$message = $session->message;
	
	if(isset($_POST['submit']))
	{
		$name 	= trim($_POST['name']);
		$info 	= trim($_POST['info']);
		$image 	= $_FILES['image'];
		
		$recipe->name 	= $name;
		$recipe->info 	= $info;
		
		if(!empty($image['tmp_name']))
		{
			if(!empty($recipe->filename))
				$recipe->delete_file();
				
			if($recipe->attach_file($image))
			{
				if($recipe->update_image())
				{
					$message = '<p class="green">Recipe added successfully.</p>';
				} else
				{
					$message = '<p class="red">';
					$message .= join("<br />", $recipe->errors);
					$message .= '</p>';
				}
			}
		} else
		{
			if($recipe->update())
			{
				$message = '<p class="green">Recipe information updated successfully.</p>';
			} else
			{
				$message = '<p class="red">Recipe information could not be saved. Please try again.</p>';
			}
		}
		
	} else
	{
		$name = $recipe->name;
		$info = $recipe->info;
	}
		
?>
<?php include_layout('html.php'); ?>
		<title>Admin - Edit Recipe</title>
		<meta name="keywords" content="" />
		<meta name="description" content="" />
		<script type="text/javascript" src="/admin/ckeditor/ckeditor.js"></script>
<?php include_layout('header-admin.php'); ?>
			
				<div id="main">
						<div class="content">
							
							<div class="info">
								<div class="head">
									<h1 class="right">EDIT RECIPE</h1>
									<h2><?php echo strtoupper($recipe->name); ?></h2>
								</div>
								
								<div class="admin">
									
									<?php if(!empty($message)) echo $message; ?>
								
									<a href="edit-recipes.php"><b>BACK TO LIST</b></a>&nbsp;&nbsp;|&nbsp;
									<a href="delete-recipe.php?id=<?php echo $id; ?>" onclick="return confirm('Are you sure you want to delete this recipe?');"><b>DELETE RECIPE</b></a><br/><br/><br/><br/>
									
									<?php if(!empty($recipe->filename)) 
									{ ?>
									<img src="/<?php echo $recipe->image_display(); ?>" />
									<?php } ?>
									
									<form action="edit-recipe.php?id=<?php echo $id; ?>" method="post" enctype="multipart/form-data">
									
										<div class="row">
											<label>Name:</label>
											<input type="text" name="name" value="<?php echo $name; ?>" size="30" />
										</div>
										
										<div class="row">
											<label>New Image:</label>
											<input type="file" name="image" value="" size="30" />
										</div>
										
										<div class="row">
											<label>Details:</label><br/>
											<textarea name="info" class="ckeditor"><?php echo $info; ?></textarea>
										</div>
										
										<div class="row">
											<label></label>
											<input type="submit" name="submit" value="Submit" />
											&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
											<input type="reset" name="reset" value="Reset" />
										</div>
									</form>
								
									<a href="logout.php"><b>&raquo; LOGOUT</b></a>
									
								</div>
								
							</div>
							
						</div>
					</div>
				
<?php include_layout('footer-admin.php'); ?>