<?php 
// Define the core paths
// Define them as absolute paths to make sure that require_once works as expected

// DIRECTORY_SEPARATOR is a PHP pre-defined constant
// (\ for Windows, / for Unix)

defined('DS') ? null : define('DS', DIRECTORY_SEPARATOR);

defined('SITE_ROOT') ? null : define('SITE_ROOT', DS.'usr'.DS.'www'.DS.'users'.DS.'citybexjcm');

defined('LIB_PATH') ? null : define('LIB_PATH', SITE_ROOT.DS.'gourmet-market-cape-town-includes');

// load config file first
require_once(LIB_PATH.DS.'market-cape-town-config.php');

// load basic functions next so that everything after can use them
require_once(LIB_PATH.DS.'market-cape-town-functions.php');

// load core objects
require_once(LIB_PATH.DS.'market-cape-town-session.php');
require_once(LIB_PATH.DS.'market-cape-town-database.php');

// load database-related classes
require_once(LIB_PATH.DS.'market-cape-town-user.php');
require_once(LIB_PATH.DS.'cape-town-market-trader.php');
require_once(LIB_PATH.DS.'cape-town-market-recipe.php');
require_once(LIB_PATH.DS.'cape-town-market-banner.php');
require_once(LIB_PATH.DS.'cape-town-market-social-media.php');
require_once(LIB_PATH.DS.'cape-town-market-time.php');
require_once(LIB_PATH.DS.'cape-town-market-subscriber.php');
require_once(LIB_PATH.DS.'cape-town-market-section.php');
require_once(LIB_PATH.DS.'cape-town-market-image.php');
require_once(LIB_PATH.DS.'cape-town-market-featured.php');

?>