<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	if(!isset($_GET['id']))
	{
		$session->message('<p class="red">No enquiry number was provided.</p>');
		redirect_to('manage-enquiries.php');
	} else
	{
		$id = trim($_GET['id']);
		$enquiry = Enquiry::find_by_id($id);
		$tour = Tour::find_by_id($enquiry->tours_id);
		$serv = Service::find_by_id($tour->services_id);
		$client = Client::find_by_id($enquiry->clients_id);
	
		if($_SERVER['REQUEST_METHOD'] == "POST")
		{
			// Process form info
			$status = $_POST['status'];
			$coordinator = $_POST['coord'];
			$people = $_POST['people'];
			$start = $_POST['start'];
			$tlanguage = $_POST['tlanguage'];
			
			$firstname = $_POST['firstname'];
			$surname = $_POST['surname'];
			$clanguage = $_POST['clanguage'];
			$country = $_POST['country'];
			$contact = $_POST['contact'];
			$tel = $_POST['tel'];
			$email = $_POST['email'];
			$establishment = $_POST['establishment'];
			$esttel = $_POST['esttel'];
			$estname = $_POST['estname'];
			$address = $_POST['address'];
			$estregion = $_POST['estregion'];
			$note = $_POST['note'];
			
			$echange = "";
			$cchange = "";
			$tchange = "";
			$update = "";
			$made_by = $session->user_id;
			
			if($status != $enquiry->status)
			{
				$enqstat = new EnquiryStatus();
				$enqstat->enquiries_id = $enquiry->id;
				$enqstat->status_id = $status;
				$enqstat->create();
				$enquiry->status = $status;
				
				$busdays = BusyDay::find_by_tour($tour->id);
				foreach($busdays as $busday)
				{
					$busday->status_id = $status;
					$busday->update();
				}
				$update .= "e";
			}
			if($coordinator != $enquiry->coordinators_id)
			{
				$enquiry->coordinators_id = $coordinator;
				$echange .= 'Co-ordinator changed.<br/>';
			}
			if($people != $enquiry->no_people)
			{
				$enquiry->no_people = $people;
				$echange .= 'Number of people was changed.<br/>';
			}
			if($start != $tour->start_date)
			{
				$tour->start_date = $start;
				if($tour->guides_id != 0 && $tour->guides_id != NULL)
				{
					$guidebusy = check_guide_busy($tour->guides_id,$tour->id);
					if($guidebusy >0)
					{	
						$tour->guides_id = 0;
						$change .= 'Guide is busy on one or more of the new dates. No guide assigned<br/>';
					}
				}
				$busdays = BusyDay::find_by_tour($tour->id);
				$diff = (strtotime($start) - strtotime($tour->start_date));
				foreach($busdays as $busday)
				{
					$origdate = $busday->date;
					$busday->guides_id = $tour->guides_id;
					$busday->date = date('Y-m-d', (strtotime($origdate) + $diff));
					$busday->update();
				}
				$tchange .= 'Tour dates changed.<br/>';
			}
			if($tlanguage != $tour->languages_id)
			{
				$tour->languages_id = $tlanguage;
				$tchange .= 'Tour language changed.<br/>';
			}
			if($establishment != $client->establishments_id)
			{
				if($establishment == 'none')
				{
					if($esttel == "" || $estname = "" || $address == "" || $estregion == 'none')
					{
						$message = '<p class="red">Select a local address from the list or complete all details for another local address.</p>';
					} else
					{
						$newes = new Establishment();
						$newes->name = $estname;
						$newes->address = $address;
						$newes->tel = $esttel;
						$newes->suburbs_id = $estregion;
						$newes->create();
						$establishment = $newes->id;
					}
				}
				if(!isset($message))
				{
					$client->establishments_id = $establishment;
					$cchange = 'Client local adress updated.<br/>';
				}
			}
			if($firstname != $client->firstname && $firstname != "")
			{
				$client->firstname = $firstname;
				$cchange .= 'Client firstname changed.<br/>';
			}
			if($surname != $client->surname && $surname != "")
			{
				$client->surname = $surname;
				$cchange .= 'Client surname changed.<br/>';
			}
			if($clanguage != $client->languages_id && $clanguage != "none")
			{
				$client->languages_id = $clanguage;
				$cchange .= 'Client language changed.<br/>';
			}
			if($country != $client->countries_id && $country != "none")
			{
				$client->countries_id = $country;
				$cchange .= 'Client country of residence changed.<br/>';
			}
			if($contact != $client->communication_methods_id && $contact != "none")
			{
				$client->communication_methods_id = $contact;
				$cchange .= 'Client preferred communication method updated.<br/>';
			}
			if($tel != $client->tel && $tel != "")
			{
				$client->tel = $tel;
				$cchange .= 'Client phone number changed.<br/>';
			}
			if($email != $client->email && $email != "")
			{
				$client->email = $email;
				$cchange .= 'Client email address changed.<br/>';
			}
			if($note != "")
			{
				$newnote = new Note();
				$newnote->details = $note;
				$newnote->users_id = $made_by;
				if($newnote->create())
				{
					$enqnote = new EnquiryNote();
					$enqnote->notes_id = $newnote->id;
					$enqnote->enquiries_id = $id;
					$enqnote->create();
				}
			}
			if(!isset($message) || $message == "")
			{
				if($cchange != "")
				{
					$cchange = substr($cchange, 0, -5);
					$client->update();
					$cnote = new Note();
					$cnote->users_id = $made_by;
					$cnote->details = $cchange;
					if($cnote->create())
					{
						$clientnote = new ClientNote();
						$clientnote->clients_id = $client->id;
						$clientnote->notes_id = $cnote->id;
						$clientnote->create();
					}
				}
				if($tchange != "")
				{
					$tchange = substr($tchange, 0, -5);
					$tour->update();
					$tnote = new Note();
					$tnote->users_id = $made_by;
					$tnote->details = $tchange;
					if($tnote->create())
					{
						$tournote = new TourNote();
						$tournote->tours_id = $tour->id;
						$tournote->notes_id = $tnote->id;
						$tournote->create();
					}
				}
				if($update != "" || $echange != "")
				{
					$echange = substr($echange, 0, -5);
					$enquiry->update();
					$enote = new Note();
					$enote->users_id = $made_by;
					$enote->details = $echange;
					if($enote->create())
					{
						$enquirynote = new EnquiryNote();
						$enquirynote->enquiries_id = $enquiry->id;
						$enquirynote->notes_id = $enote->id;
						$enquirynote->create();
					}
				}
				$fullmess = '<p class="red">'.$echange;
				if($echange != "" && ($tchange != "" || $cchange != "")) $fullmess .= '<br/>';
				$fullmess .= $tchange;
				if($tchange != "" && $cchange != "") $fullmess .= '<br/>';
				$fullmess .= $cchange.'</p>';
				
				$session->message($fullmess);
				redirect_to('enquiry-details.php?id='.$id);
			}
		} else
		{
			$status = $enquiry->status;
			$coordinator = $enquiry->coordinators_id;
			$people = $enquiry->no_people;
			$start = $tour->start_date;
			$tlanguage = $tour->languages_id;
			$guide = $tour->guides_id;
			$firstname = $client->firstname;
			$surname = $client->surname;
			$clanguage = $client->languages_id;
			$country = $client->countries_id;
			$contact = $client->communication_methods_id;
			$tel = $client->tel;
			$email = $client->email;
			$establishment = $client->establishments_id;
			$esttel = "";
			$estname = "Private Accommodation";
			$address = "";
			$estregion = "";
			$note = "";		
		}
		if(!isset($message)) $message = $session->message;
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" language="JavaScript">
			function toggleLayer(whichLayer)
			{
				var elem, vis;
				if( document.getElementById ) // this is the way the standards work
				elem = document.getElementById( whichLayer );
				else if( document.all ) // this is the way old msie versions work
				elem = document.all[whichLayer];
				else if( document.layers ) // this is the way nn4 works
				elem = document.layers[whichLayer];
				vis = elem.style;
				// if the style.display value is blank we try to figure it out here
				if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
				vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
				vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
		</script>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>EDIT ENQUIRY: REF# <?php echo $enquiry->reference; ?></h1>
						
						<p><a href="enquiry-details.php?id=<?php echo $id; ?>">&laquo; BACK</a></p>
						
						<?php if(isset($message) && $message != "") echo $message; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post">
						
							<div class="row">
								<div class="label">Status</div>
								<select name="status">
									<?php 
										$stats = Status::find_all();
										foreach($stats as $stat)
										{
											echo '<option value="'.$stat->id;
											if($status == $stat->id) echo '" selected="selected';
											echo '">'.$stat->status.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Co-ordinator</div>
								<select name="coord">
									<?php 
										$coordins = Coordinator::find_all();
										foreach($coordins as $coordin)
										{
											echo '<option value="'.$coordin->id;
											if($coordin->id == $coord) echo '" selected="selected';
											echo '">'.$coordin->name.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Number of People</div>
								<select name="people">
									<?php 
										for($i = 1; $i <= 100; $i++)
										{
											echo '<option value="'.$i;
											if($i == $people) echo '" selected="selected';
											echo '">'.$i.'</option>';
										}
									?>
								</select>
							</div>
							
							<?php	 
							if($serv->types_id != 2)
							{ ?>
								<div class="row">
									<div class="label">Start date</div>
									<script>
										$(function() {
											$( "#datepicker" ).datepicker({
												dateFormat: 'dd/mm/yy'
												});
										});
									</script>
									<input type="text" name="start" value="<?php echo $start; ?>" id="datepicker"  size="20" />
								</div>
							<?php } else
								{
									echo '<input type="hidden" name="start" value="'.$start.'" />';
								} ?>
							
							<div class="row">
								<div class="label">Tour Language</div>
								<select name="tlanguage">
									<?php 
										$langs = Language::find_all();
										foreach($langs as $lang)
										{
											echo '<option value="'.$lang->id;
											if($lang->id == $tlanguage) echo '" selected="selected';
											echo '">'.$lang->language.'</option>';
										}
									?>
								</select>
							</div>								
							
							<div class="row">
								<h2>CLIENT DETAILS</h2>
							</div>
							
							<div class="row">
								<div class="label">First Name</div>
								<input type="text" name="firstname" value="<?php echo $firstname; ?>" size="30" />
							</div>
							
							<div class="row">
								<div class="label">Surname</div>
								<input type="text" name="surname" value="<?php echo $surname; ?>" size="30" />
							</div>
							
							<div class="row">
								<div class="label">Country of Residence</div>
								<select name="country">
									<?php 
										$countris = Country::find_all();
										foreach($countris as $countri)
										{
											echo '<option value="'.$countri->id;
											if($countri->id == $country) echo '" selected="selected';
											echo '">'.$countri->country.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Preferred Language</div>
								<select name="clanguage">
									<?php 
										foreach($langs as $lang)
										{
											echo '<option value="'.$lang->id;
											if($lang->id == $clanguage) echo '" selected="selected';
											echo '">'.$lang->language.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Preferred Contact</div>
								<select name="contact">
									<?php 
										$meths = CommunicationMethod::find_all();
										foreach($meths as $meth)
										{
											echo '<option value="'.$meth->id;
											if($meth->id == $contact) echo '" selected="selected';
											echo '">'.$meth->name.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Telephone</div>
								<input type="text" name="tel" value="<?php echo $tel; ?>" size="30" />
							</div>
							
							<div class="row">
								<div class="label">Email</div>
								<input type="text" name="email" value="<?php echo $email; ?>" size="30" />
							</div>
							
							<div class="row">
								<div class="label">Local Address</div>
								<select name="establishment">
									<option value="none">Other</option>
									<?php 
										$ests = Establishment::find_all();
										foreach($ests as $est)
										{
											echo '<option value="'.$est->id;
											if($est->id == $establishment) echo '" selected="selected';
											echo '">'.$est->name.'</option>';
										}
									?>
								</select>
								&nbsp; <a href="javascript:toggleLayer('dates');">+ If other, add new establishment</a>
							</div>
							
							<div id="dates">
								<div class="row">
									<div class="label">Name</div>
									<input type="text" name="estname" value="" size="30" />
								</div>
								
								<div class="row">
									<div class="label">Telephone</div>
									<input type="text" name="esttel" value="" size="30" />
								</div>
								
								<div class="row">
									<div class="label">Address</div>
									<input type="text" name="address" value="" size="30" />
								</div>
								
								<div class="row">
									<div class="label">Suburb</div>
									<select name="estregion">
										<?php 
											$regs = Suburb::find_all();
											foreach($regs as $reg)
											{
												echo '<option value="'.$reg->id.'">'.$reg->suburb.'</option>';
											}
										?>
									</select>
								</div>
							</div>
							
							<div class="row">
								<h2>ADD NOTE</h2>
							</div>
							<div class="row">
								<textarea name="note" rows="4" cols="40"></textarea>
							</div>
							
							<div class="row">
								<input type="submit" name="submit" value="Update" />
								<input type="reset" name="reset" value="Reset" />
							</div>
						</form>
					</div>
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>