<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	$message = $session->message;
	
	if(isset($_GET['id']))
	{
		$id = trim($_GET['id']);
		$service = Service::find_by_id($id);
	} else
	{
		$session->message("No service ID was provided.");
		redirect_to('manage-listings.php');
	}
	?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$title = trim($_POST['title']);
		$intro = trim($_POST['intro']);
		$details = trim($_POST['details']);
		$duration = trim($_POST['duration']);
		$price = trim($_POST['price']);
		$deposit = trim($_POST['deposit']);
		$region = trim($_POST['region']);
		$othregion = trim($_POST['othregion']); // error if region = none and othregion = ""
		$position = trim($_POST['position']);
		$orig_position = trim($_POST['orig_position']);
		$current = trim($_POST['current']);
		$orig_current = trim($_POST['orig_current']);
		
		if($current == 0 && $orig_current == 1)
		{
			$position = 0;
		}
		
		//Check for errors
		$error = "";
		if($title == "")
		{
			$error .= "Title can not be blank. Please add a title.<br/>";
		}
		if(!ctype_digit($price))
		{
			$error .= "Only numbers are accepted for price. Please re-enter the price.<br/>";
		}
		if(!ctype_digit($deposit))
		{
			$error .= "Only numbers are accepted for deposit percentage. Please re-enter the amount.<br/>";
		}
		if($region == 'none' && $othregion == "")
		{
			$error .= "No region was selected. Please select a region or enter a new region name.<br/>";
		}
		
		if($error != "")
		{
			$message = '<p class="red">There are errors.<br/>';
			$message .= $error;
			$message .= '</p>';
		} else
		{			
			$service->title = $title;
			$service->intro = $intro;
			$service->details = $details;
			$service->duration = $duration;
			$service->price = $price;
			$service->deposit = $deposit;
			if($othregion != "")
			{
				$reg_exist = Region::find_by_region($othregion);
				if(!$reg_exist)
				{
					$region = new Region();
					$region->region = $othregion;
					$region->create();
					$service->regions_id = $region->id;
				} else
				{
					$service->regions_id = $reg_exist->id;
				}
			} else
			{
				$service->regions_id = $region;
			}
			$service->position	= $position;
			$service->orig_position = $orig_position;
			$service->current	= $current;
			$service->orig_current = $orig_current;
			
			if($service->update())
			{
				$message = '<p class="red">Service updated successfully.</p>';
			//	redirect_to('manage-services.php');
				$service = Service::find_by_id($id);
			} else
			{
				$message = join("<br />", $service->errors);
			}
		}
	} else
	{
		$title = $service->title;
		$intro = $service->intro;
		$details = $service->details;
		$duration = $service->duration;
		$price = $service->price;
		$deposit = $service->deposit;
		$region = $service->regions_id;
		$othregion = "";
		$current = $service->current;
		$position = $service->position;
	}
?>
<?php include_layout('html.php')?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" src="/ctgc/admin/ckeditor/ckeditor.js"></script>

<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
						<h1>EDIT SERVICE: <?php echo strtoupper($service->title); ?></h1>
						
						<p>
							<a href="change-service-status.php?id=<?php echo $id; ?>" ><?php 
								if($service->current == 1)  
								{
									echo 'MAKE SERVICE INACTIVE';
								} else
								{
									echo 'ACTIVATE SERVICE';
								}
							
							?></a> &nbsp;|&nbsp;
							<a href="replace-service-image.php?id=<?php echo $id; ?>" >REPLACE IMAGE</a> &nbsp;|&nbsp;
							<a href="manage-<?php if($service->types_id == 1) echo 'listings';
							else echo 'other-services'; ?>.php">CANCEL</a> 
						</p>
						
						<?php if(isset($message) && $message != "") echo $message.'<br/><br/>'; ?>
						
						<img src="/ctgc/<?php echo $service->image_display(); ?>" width="130px" /><br/><br/>
						
						<form method="post" action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" enctype="multipart/form-data">
							
							<div class="row">
								<div class="label">Title</div>
								<input type="text" name="title" value="<?php echo $title; ?>" size="40" />
							</div>
						
							<div class="row">
								<br/><div class="label">Summary</div><br/>
								<textarea class="ckeditor" name="intro"><?php echo $intro; ?></textarea>
							</div>
							
							<div class="row">
								<br/><div class="label">Full Details</div><br/>
								<textarea class="ckeditor" name="details"><?php echo $details; ?></textarea>
							</div>
							
							<div class="row">
								<div class="label">Duration (days)</div>
								<select name="duration">
									<?php 
										for($i = 1; $i <= 30; $i++)
										{
											echo '<option value="'.$i.'">'.$i.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Price pp (ZAR)</div>
								<input type="text" name="price" size="10" value="<?php echo $price; ?>" />
							</div>
							
							<div class="row">
								<div class="label">Deposit Required:</div>
								<input type="text" name="deposit" size="3" value="<?php echo $deposit;?>" /> %
							</div>
							
							<div class="row">
								<div class="label">Region</div>
								<select name="region">
									<option value="none">Other...</option>
									<?php 
										$regs = Region::find_all();
										foreach($regs as $reg)
										{
											echo '<option value="'.$reg->id;
											if($reg->id == $region) echo '" selected="selected';
											echo '">'.$reg->region.'</option>';
										}
									?>
									<option value="none">Other...</option>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Or NEW Region</div>
								<input type="text" name="othregion" value="<?php echo $othregion; ?>" />
								<label class="red"> * If not blank, region selected above will be ignored</label>
							</div>
							
							<div class="row">
								<div class="label">Position</div>
								<select name="position">
									<option value="1" <?php if($position == 1) echo 'selected="selected"'; ?>>1</option>
									<?php 
										if($service->types_id == 1) $cat_services = Service::find_listings_by_category($service->categories_id, 'AND current = 1'); 
										else $cat_services = Service::find_services_by_category($service->categories_id, 'AND current = 1');
										$count = count($cat_services);
										for($i = 2; $i <= $count+1; $i++)
										{
											echo '<option value="'.$i;
											if($i == $position) echo '" selected="selected';
											echo '">'.$i.'</option>';
										}
									?>
								</select>
								<input type="hidden" name="orig_position" value="<?php echo $service->position; ?>" />
							</div>
							
							<div class="row">
								<input type="radio" name="current" value="1" <?php if($current ==1) echo 'checked="checked"'; ?> />
								Display as current service
								| <input type="radio" name="current" value="0" <?php if($current ==0) echo 'checked="checked"'; ?> />
								Archived service / not in use
								
								<input type="hidden" name="orig_current" value="<?php echo $service->current; ?>" />
							</div>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" />
							</div>
						</form>
						<div class="row">
							<h2>GALLERY IMAGES</h2>
							
							<div class="listing">
								<div class="image_container" >
							
									<?php 
										$images = Image::find_by_service($id);
										if(empty($images))
										{
											echo '<p>There are no gallery images for this service.</p>';
										} else
										{
											foreach($images as $image)
											{
												echo '<div class="gallery"><img src="/ctgc/'.$image->thumb_display().'" width="110px" height="110px" />';
												echo '<div class="options">';
												echo '<p><a href="edit-service-image.php?id='.$image->id.'">EDIT</a><br/>';
												echo '<a href="delete-service-image.php?id='.$image->id.'" onclick="return confirm(\'Are you sure you want to delete this image?\');" >DELETE</a></p>';
												echo '</div></div>';
											}
										}
									?>
								</div>
							</div>
							
							<p>
								<a href="upload-service-image.php?service=<?php echo $id; ?>" >+ Add Image</a>
							</p>
							
						</div>
					
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>