<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	if(isset($_GET['id']))
	{
		$id = trim($_GET['id']);
		$tour = Tour::find_by_id($id);
		$service = Service::find_by_id($tour->services_id);
	} else
	{
		$session->message('<p class="red">No tour was selected.</p>');
		redirect_to('manage-tours.php');
	}
	?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{	
		$error = "";
		if($_POST['date'] == "")
		{
			$error .= ' A start date must be selected.<br/>';
		} else
		{
			$date			= date('Y-m-d', strtotime(str_replace('/','-', trim($_POST['date']))));
		}
		$capacity = trim($_POST['capacity']);
		$more_capacity = trim($_POST['more_capacity']);
		$language = trim($_POST['language']);
		
		if($language == 'none')
		{
			$error .= ' A language must be selected.<br/>';
		}
		if($capacity == 'none' && $more_capacity == "")
		{
			$error .= ' Tour capacity must be selected.<br/>';
		}
		
		if($error != "")
		{
			$message = '<p class="red">There are errors.<br/>';
			$message .= $error;
			$message .= '</p>';
		} else
		{		
			if($tour->start_date != $date)
			{
				$busy_olds = BusyDay::find_by_tour($id);
				foreach($busy_olds as $busy_old)
				{
					$status = $busy_old->status_id;
					$guide	= $busy_old->guides_id;
					$busy_old->delete();
				}
				for($k = 0; $k < $service->duration; $k++)
				{
					$busy_day = new BusyDay();
					$busy_day->date = date('Y-m-d', (strtotime($date) + $k*86400));
					$busy_day->tours_id = $tour->id;
					if($guide)
					{
						$busy_day->guides_id = $guide;
					} else
					{
						$busy_day->guides_id = 0;
					}
					$busy_day->status_id = $status;
					$busy_day->create();
				}
				$tour->start_date = $date;
			}
			if($more_capacity != "")
			{
				$tour->capacity = $more_capacity;
			} else
			{
				$tour->capacity = $capacity;
			}
			$tour->languages_id = $language;
			
			if($tour->update())
			{
				$session->message('<p class="red">Tour date updated successfully.</p>');
				redirect_to('select-tour-guide.php?tour='.$tour->id);
			} else
			{
				$message = join("<br />", $service->errors);
			}
		}
	} else
	{
		$date 			= date('d/m/Y', strtotime($tour->start_date));
		$capacity 		= $tour->capacity;
		$more_capacity 	= "";
		$language		= $tour->languages_id;
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />	
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>EDIT SET TOUR: <?php echo strtoupper($service->title).' ON '.$tour->start_date; ?></h1>
						
						<p>
							<a href="edit-tour.php?id=<?php echo $tour->services_id; ?>">CANCEL</a> 
						</p>
						
						<?php if(isset($session->message) && $session->message != "") echo $session->message.'<br/>'; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post" />
						
							<div class="row">
								<div class="label">Departure date:</div>
								<script>
									$(function() {
										$( "#datepicker" ).datepicker({
											dateFormat: 'dd/mm/yy'
											});
									});
								</script>
								<input type="text" name="date" value="<?php echo $date; ?>" id="datepicker"  size="20" />
							</div>
							
							<div class="row">
								<div class="label">Capacity:</div>
								<select name="capacity">
									<?php 
										for($i=1; $i<=30; $i++)
										{
											echo '<option value="'.$i;
											if($i == $capacity) echo '" selected="selected';
											echo '" >'.$i.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">or More:</div>
								<input type="text" name="more_capacity" size="3" value="<?php echo $more_capacity; ?>" />
							</div>
							
							<div class="row">
								<div class="label">Language:</div>
								<select name="language">
									<?php 
										$langs = Language::find_all();
										foreach($langs as $lang)
										{
											echo '<option value="'.$lang->id;
											if($language == $lang->id) echo '" selected="selected';
											echo '">'.$lang->language.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" />
							</div>
						
						</form>
													
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>