<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	?>
<?php 
	if(isset($_GET['id']))
	{
		$id = trim($_GET['id']);
		$enq = Enquiry::find_by_id($id);
		$enquiry = get_enquiry_details($enq->reference);
		$client = $enq->clients_id;
		$stat = Status::find_by_id($enquiry['status']);
		$coord = Coordinator::find_by_id($enq->coordinators_id);
		if($enquiry['guides_id'] != NULL)
		{
			$guide = Guide::find_by_id($enquiry['guides_id']);
		}
	} else
	{
		$session->message("No enquiry number was provided.");
		redirect_to('manage-enquiries.php');
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript">
			<!--
			function popup(mylink, windowname, dimensions)
			{
			if (! window.focus)return true;
			var href;
			if (typeof(mylink) == 'string')
			   href=mylink;
			else
			   href=mylink.href;
			window.open(href, windowname, dimensions);
			return false;
			}
			//-->
		</script>
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
						<h1>ENQUIRY DETAILS</h1>
						
						<h2>REF# <?php echo $enquiry['reference']; ?></h2>
						<p>
							<a href="edit-enquiry.php?id=<?php echo $id; ?>">EDIT</a> &nbsp;|&nbsp;
							<a href="enquiry-note.php?id=<?php echo $id; ?>" onclick="return popup(this, 'Update Enquiry Status', 'width=480,height=330,scrollbar=yes')">ADD NOTE</a> &nbsp;|&nbsp;
							<a href="update-status.php?id=<?php echo $id; ?>" onclick="return popup(this, 'Update Enquiry Status', 'width=280,height=240,scrollbar=yes')">UPDATE STATUS</a> &nbsp;|&nbsp;
							<a href="send-email.php?ref=<?php echo $enquiry['reference']; ?>">SEND EMAIL</a>
						</p>
						
						<?php if(isset($session->message) && $session->message != "") echo $session->message; ?>
						
						<table class="borderless">
							<tr><td width="180px">Current Status: </td><td><b><?php echo $stat->status; ?></b></td></tr>
							<tr><td>Co-ordinator:</td><td> <?php echo $coord->name; ?></td></tr>
						</table>
						
						<h2>TOUR DETAILS</h2>
						<table class="borderless">
							<tr><td width="180px">Tour/Service:</td><td> <?php echo $enquiry['title']; ?>
							<?php 
								$tour = Tour::find_by_id($enq->tours_id);
								$service = Service::find_by_id($tour->services_id);
								if($service->types_id == 4)
								{
									echo '<br/><a href="edit-ad-hoc.php?service='.$service->id.'">EDIT DETAILS</a>';
								}
							?>
							</td></tr>
							<tr><td>No People:</td><td> <?php echo $enquiry['people']; ?></td></tr>
							<?php $phpstart = strtotime($enquiry['start_date']); ?>
							<tr><td>Tour Date/s:</td><td> <?php echo date('d m Y', $phpstart);  
							if($enquiry['duration'] >1) echo ' - '.date('d m Y', ($phpstart +(($enquiry['duration'] -1) * 86400))); ?></td></tr>
							<tr><td>Language:</td><td> <?php echo $enquiry['tlanguage']; ?></td></tr>
							<tr><td>Guide:</td><td> <a href="select-tour-guide.php?tour=<?php echo $enq->tours_id;?>" title="Change guide"><?php if(isset($guide)) echo $guide->firstname.' '.$guide->surname;
							else echo 'None assigned yet.'; ?></a></td></tr>
							<tr><td>Vehicle/s: </td><td><?php 
								$vehicles = Vehicle::find_by_tour($id);
								foreach($vehicles as $vehicle)
								{
									$veh = get_vehicle_details($vehicle->id);
									if($vehicle->guides_id > 0)
									{
										$owner = $veh['firstname'].' '.$veh['surname'];
									} else
									{
										$owner = 'Not assigned to a specific guide.';
									}
									echo '<a href="remove-tour-vehicle.php?tour='.$id.'&veh='.$veh['id'].'" title="Remove vehicle from Tour" onclick="return confirm(\'Are you sure you want to remove this vehicle?\');">';
									echo $veh['make'].' '.$veh['model'].' '.$veh['year'].', seats: '.$veh['capacity'].', '.$veh['colour'];
									echo '<br/>Owner: '.$owner.'</a><br/>';
								}
							?>
							&nbsp;&nbsp;&nbsp;<a href="select-tour-vehicle.php?tour=<?php echo $enq->tours_id; ?>" >+ ADD VEHICLE</a>
							</td></tr>
						</table>
						
						<h2>CLIENT DETAILS</h2>
						<table class="borderless">
							<tr><td width="180px">Name:</td><td> <?php echo $enquiry['cfirstname'].' '.$enquiry['csurname']; ?></td></tr>
							<tr><td>Country:</td><td> <?php echo $enquiry['country']; ?></td></tr>
							<tr><td>Preferred contact method:</td><td> <?php echo $enquiry['communication_method']; ?></td></tr>
							<tr><td>Tel:</td><td> <?php echo $enquiry['ctel']; ?></td></tr>
							<tr><td>Email:</td><td> <?php echo $enquiry['cemail']; ?></td></tr>
							<tr><td>Local address:</td><td> <?php echo $enquiry['esname'].' - '.$enquiry['address']; ?></td></tr>
						</table>
						
						<h2>PAYMENT INFORMATION</h2>
						<table class="borderless">
							<tr><td width="180px">Total Cost:</td><td>R <?php echo $enquiry['total_cost']; ?></td></tr>
							<tr><td>Payment Due Now:</td><td>R <?php echo $enquiry['due_now']; ?></td></tr>
						</table>
						
						<p>
							<a href="enquiry-payments.php?ref=<?php echo $enquiry['reference']; ?>">
								<button>All Details / Add payment</button>
							</a>
						</p>
						
						<h2>ADDITIONAL INFORMATION</h2>
						<?php 
							$status_updates = EnquiryStatus::find_by_enquiry($enq->id);
							foreach($status_updates as $status_update)
							{
								$status = Status::find_by_id($status_update->status_id);
								echo '<p>Status Update: "'.$status->status.'" on '.date('d M Y H:i:s', strtotime($status_update->timestamp)).'</p>';
							}
							$enotes = Note::find_by_enquiry($enq->id);
							foreach($enotes as $enote)
							{
								$user = User::find_by_id($enote->users_id);
								$coordinator = Coordinator::find_by_id($user->coordinators_id);
								echo '<p>'.$enote->details;
								echo '<br/><label class="small"> - Added by '.$coordinator->name.' at '.$enote->timestamp.'</label></p>';
							}
							$tnotes = Note::find_by_tour($tour->id);
							foreach($tnotes as $tnote)
							{
								$user = User::find_by_id($tnote->users_id);
								$coordinator = Coordinator::find_by_id($user->coordinators_id);
								echo '<p>'.$tnote->details;
								echo '<br/><label class="small"> - Added by '.$coordinator->name.' at '.$tnote->timestamp.'</label></p>';
							}
							$cnotes = Note::find_by_client($client);
							foreach($cnotes as $cnote)
							{
								$user = User::find_by_id($cnote->users_id);
								$coordinator = Coordinator::find_by_id($user->coordinators_id);
								echo '<p>'.$cnote->details;
								echo '<br/><label class="small"> - Added by '.$coordinator->name.' at '.$cnote->timestamp.'</label></p>';
							}
						?>
						
					</div>
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>