<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	?>
<?php 
	if(!isset($_GET['ref']))
	{
		$session->message('<p class="red">No enquiry number was provided.</p>');
		redirect_to('manage-enquiries.php');
	} else
	{
		$message = $session->message;
		$ref = trim($_GET['ref']);
		$enquiry = Enquiry::find_by_reference($ref);
		
		if($_SERVER['REQUEST_METHOD'] == "POST")
		{
			// process and add details.
			$amount = trim($_POST['amount']);
			$date = trim($_POST['date']);
			$method = trim($_POST['method']);
			$reference =trim($_POST['reference']); 
			$comments = trim($_POST['comments']);
			
			$error = "";
			if($amount == "" || $amount == 0) $error .= 'Payment Amount.<br/>';
			else if(!is_numeric($amount)) $error .= 'Payment Amount must be a number.<br/>';
			if($date == "" || $date == 'dd/mm/yyyy') $error .= 'Payment Date.<br/>';
			if($reference == '') $error .= 'Payment Reference.<br/>';
			
			if($error != "")
			{
				$message = '<p class="red">SOME REQUIRED FIELDS ARE BLANK> PLEASE COMPLETE THE FOLLOWING INFORMATION:<br/>'.$error.'</p>';
			} else
			{
				$pmt = new Payment();
				$pmt->date = date('Y-m-d', strtotime($date));
				$pmt->enquiries_ref = $ref;
				$pmt->reference = $reference;
				$pmt->amount = $amount;
				$pmt->payment_methods_id = $method;
				$pmt->create();
				
				if($enquiry->due_now>0)
				{
					$new_amt = $enquiry->due_now - $amount;
					
					if($new_amt < 0) $enquiry->due_now = 0;
					else $enquiry->due_now = $new_amount;
					
					$enquiry->update();
				}
			}
		} else
		{
			$payments = Payment::find_by_enquiry($ref);
			$count = count($payments);
			$total = Payment::find_enquiry_amount($ref);
			$date = date('d/m/Y');
			$amount = "";
			$reference = $enquiry->reference.' - '.($count+1);
			$method = "";
			$comments = "";
		}
		$payments = Payment::find_by_enquiry($ref);
		$count = count($payments);
		$total = Payment::find_enquiry_amount($ref);
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript">
			<!--
			function popup(mylink, windowname, dimensions)
			{
			if (! window.focus)return true;
			var href;
			if (typeof(mylink) == 'string')
			   href=mylink;
			else
			   href=mylink.href;
			window.open(href, windowname, dimensions);
			return false;
			}
			//-->
		</script>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
						<h1>PAYMENT INFORMATION FOR ENQUIRY REF# <?php echo $enquiry->reference; ?></h1>
						
						<?php if(isset($message) && $message != "") echo $message; ?>
						
						<table class="borderless">
							<tr><td width="180px">Total Cost:</td><td>R <?php echo $enquiry->total_cost; ?></td></tr>
							<tr><td>Booking deposit:</td><td>R <?php echo $enquiry->deposit; ?></td></tr>
							<tr><td>Total payments received</td><td>R <?php echo $total; ?></td></tr>
							<tr><td>Payment Due Now:</td><td>R <?php echo $enquiry->due_now; ?></td></tr>
						</table>
						
						<h2>PAYMENTS RECEIVED</h2>
						
						<?php 
							foreach($payments as $payment)
							{
								$method = PaymentMethod::find_by_id($payment->payment_methods_id);
								echo '<p><b>REFERENCE: '.$payment->reference.'</b></b>';
								echo '<table class="borderless">';
								echo '<tr><td width="180px">Amount</td><td>R '.$payment->amount.'</td></tr>';
								echo '<tr><td>Payment Date</td><td>'.date('d M Y H:i:s', strtotime($payment->date)).'</td></tr>';
								echo '<tr><td>Payment Method</td><td>'.$method->method.'</td></tr>';
								echo '<tr><td>Comments</td><td>'.$payment->comments.'</td></tr>';
								echo '</table>';
							} 
						?>
						
						<h2>ADD NEW PAYMENT DETAILS</h2>
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post" >
						
							<div class="row">
								<div class="label">Amount Received (ZAR)</div>
								<input type="text" name="amount" value="<?php echo $amount; ?>" size="10" />
							</div>
							
							<div class="row">
								<div class="label">Payment Date</div>
								<script>
									$(function() {
										$( "#datepicker" ).datepicker({
											dateFormat: 'dd/mm/yy'
											});
									});
								</script>
								<input type="text" name="date" value="<?php echo $date; ?>" id="datepicker"  size="20" />
							</div>
							
							<div class="row">
								<div class="label">Payment Method</div>
								<select name="method">
									<?php 
										$meths = PaymentMethod::find_all();
										foreach($meths as $meth)
										{
											echo '<option value="'.$meth->id;
											if($meth->id == $method) echo '" selected="selected';
											echo '">'.$meth->method.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Payment Reference</div>
								<input type="text" size="30" name="reference" value="<?php echo $reference; ?>" />
							</div>
							
							<div class="row">
								<div class="label">Comments</div>
								<textarea name="comments" cols="40" rows="5"><?php echo $comments; ?></textarea>
							</div>
							
							<div class="row">
								<div class="label">&nbsp;</div>
								<input type="submit" name="submit" value="submit" />
							</div>
						
						</form>
						
					</div>
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>