<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");}

	$message = $session->message;
	
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		if(isset($_POST['delete']))
		{
			$deletestring = implode(', ', $_POST['delete']);
			$delets = explode(', ', $deletestring);
			foreach($delets as $delet)
			{
				$delbranch = BankBranch::find_by_id($delet);
				$delbranch->delete();
			}
		}
		
		$branches = BankBranch::find_all();
		foreach($branches as $branch)
		{
			$branch->banks_id = trim($_POST['bank'.$branch->id]);
			$branch->name = trim($_POST['name'.$branch->id]);
			$branch->code = trim($_POST['code'.$branch->id]);
			if($branch->banks_id != 0 && $branch->name != "")
				$branch->update();
			else $message .= '<p class="red">Could not update "'.$branch->name.'". Bank and branch name must be provided.</p>';
		}
		
		for($j = 1; $j < 4; $j++)
		{
			if($_POST['newbranch'.$j] != "" && $_POST['newbank'.$j] != 0)
			{
				$bank_id = trim($_POST['newbank'.$j]);
				$name = trim($_POST['newbranch'.$j]);
				$newcode = trim($_POST['newcode'.$j]);
				$branchexists = BankBranch::find_by_name($name, $bank_id);
				if(!$branchexists)
				{
					$newbranch = new BankBranch();
					$newbranch->name = $name;
					$newbranch->code = $newcode;
					$newbranch->banks_id = $bank_id;
					$newbranch->create();
				} else 
				$message .= '<p class="red">Branch called "'.$name.'" already exists.</p>';
			}
		}
	}
	?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>MANAGE BANK BRANCHES</h1>
						
						<p><a href="manage-database.php">&laquo; BACK</a></p>
						
						<?php if($message != "") echo $message; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post" >
							
							<h2>NEW BRANCHES</h2>
							
							<table class="borderless">
								<th>BANK</th>
								<th>BRANCH NAME</th>
								<th>BRANCH CODE</th>
								<?php 
								$banks = Bank::find_all();
									for($i = 1; $i<4; $i++)
									{
								?>
									<tr><td>
										<select name="newbank<?php echo $i; ?>">
											<option value="0">Select Bank...</option>
										<?php 
											foreach($banks as $bank)
												echo '<option value="'.$bank->id.'">'.$bank->name.'</option>';
										?>
										</select>
									</td><td>
										<input type="text" size="20" name="newbranch<?php echo $i;?>" />
									</td><td>
										<input type="text" size="12" name="newcode<?php echo $i; ?>" />
									</td></tr>
								<?php } ?>
							</table>
							
							<h2>EXISTING RECORDS</h2>
							<table class="borderless">
								<th>BANK</th>
								<th>BRANCH NAME</th>
								<th>BRANCH CODE</th>
								<th>&nbsp;</th>
								<?php 
								$branches = BankBranch::find_all();
								foreach($branches as $branch)
								{
								?>
								<tr><td>
									<select name="bank<?php echo $branch->id;?>">
										<option value="0">Select Bank...</option>
										<?php 
											foreach($banks as $bank)
											{ 
												echo '<option value="'.$bank->id;
												if($branch->banks_id == $bank->id) echo '" selected="selected';
												echo '">'.$bank->name.'</option>';
											}	
										?>
									</select>
								</td><td>
									<input type="text" size="20" name="name<?php echo $branch->id; ?>" value="<?php echo $branch->name; ?>" />
								</td><td>
									<input type="text" size="12" name="code<?php echo $branch->id; ?>" value="<?php echo $branch->code; ?>" />
								</td><td>
									<input type="checkbox" name="delete[]" value="<?php echo $branch->id; ?>" /> DELETE	
								</td></tr>
								<?php }?>
								</table>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" /> &nbsp;<input type="reset" name="reset" value="Reset" />
							</div>
							
						</form>
						
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>