<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");}

	$message = $session->message;
	
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		if(isset($_POST['delete']))
		{
			$deletestring = implode(', ', $_POST['delete']);
			$delets = explode(', ', $deletestring);
			foreach($delets as $delet)
			{
				$delest = Establishment::find_by_id($delet);
				$delest->delete();
			}
		}
		
		$establishments = Establishment::find_all();
		foreach($establishments as $establishment)
		{
			$establishment->suburbs_id = trim($_POST['suburb'.$establishment->id]);
			$establishment->name = trim($_POST['name'.$establishment->id]);
			$establishment->address = trim($_POST['address'.$establishment->id]);
			$establishment->tel = trim($_POST['tel'.$establishment->id]);
			$establishment->list = trim($_POST['list'.$establishment->id]);
			if($establishment->suburbs_id != 0 && $establishment->name != "" && $establishment->address != "")
				$establishment->update();
			else $message .= '<p class="red">Could not update "'.$establishment->name.'". Suburb, name and address must be provided.</p>';
		}
		
		for($j = 1; $j < 4; $j++)
		{
			if($_POST['newsuburb'.$j] != "" && $_POST['newname'.$j] != "" && $_POST['newaddress'.$j] != "")
			{
				$suburbs_id = trim($_POST['newsuburb'.$j]);
				$name = trim($_POST['newname'.$j]);
				$address = trim($_POST['newaddress'.$j]);
				$tel = trim($_POST['newtel'.$j]);
				$list = trim($_POST['newlist'.$j]);
				$estexists = Establishment::find_by_name($name, $address, $suburbs_id);
				if(!$estexists)
				{
					$newest = new Establishment();
					$newest->name = $name;
					$newest->address = $address;
					$newest->tel = $tel;
					$newest->suburbs_id = $suburbs_id;
					$newest->list = $list;
					$newest->create();
				} else 
				$message .= '<p class="red">Establishment "'.$name.': '.$address.'" already exists.</p>';
			}
		}
	}
	?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>MANAGE ESTABLISHMENTS / LOCAL ACCOMMODATION</h1>
						
						<p><a href="manage-database.php">&laquo; BACK</a></p>
						
						<?php if($message != "") echo $message; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post" >
							
							<h2>NEW ESTABLISHMENTS</h2>
							
							<table class="borderless">
								<th>SUBURB</th>
								<th>NAME</th>
								<th>ADDRESS</th>
								<th>TELEPHONE</th>
								<th>LIST</th>
								<?php 
								$suburbs = Suburb::find_all();
									for($i = 1; $i<4; $i++)
									{
								?>
									<tr><td>
										<select name="newsuburb<?php echo $i; ?>">
											<option value="0">Select Suburb...</option>
										<?php 
											foreach($suburbs as $suburb)
												echo '<option value="'.$suburb->id.'">'.$suburb->suburb.'</option>';
										?>
										</select>
									</td><td>
										<input type="text" size="20" name="newname<?php echo $i;?>" />
									</td><td>
										<input type="text" size="30" name="newaddress<?php echo $i; ?>" />
									</td><td>
										<input type="text" size="10" name="newtel<?php echo $i; ?>" />
									</td><td>
										<select name="newlist<?php echo $i; ?>">
											<option value="1">Y</option>
											<option value="0">N</option>
										</select>
									</td></tr>
								<?php } ?>
							</table>
							
							<h2>LISTED RECORDS</h2>
							<table class="borderless">
								<th>SUBURB</th>
								<th>NAME</th>
								<th>ADDRESS</th>
								<th>TELEPHONE</th>
								<th>LIST</th>
								<th>DELETE</th>
								<?php 
								$establishments = Establishment::find_for_list();
								foreach($establishments as $establishment)
								{
								?>
								<tr><td>
									<select name="suburb<?php echo $establishment->id; ?>">
										<option value="0">Select Suburb...</option>
									<?php 
										$suburbs = Suburb::find_all();
										foreach($suburbs as $suburb)
										{
											echo '<option value="'.$suburb->id;
											if($suburb->id == $establishment->suburbs_id) echo '" selected="selected';
											echo '">'.$suburb->suburb.'</option>';
										}
									?>
									</select>
								</td><td>
									<input type="text" size="20" name="name<?php echo $establishment->id;?>" value="<?php echo $establishment->name; ?>" />
								</td><td>
									<input type="text" size="30" name="address<?php echo $establishment->id; ?>" value="<?php echo $establishment->address; ?>" />
								</td><td>
									<input type="text" size="10" name="tel<?php echo $establishment->id; ?>" value="<?php echo $establishment->tel; ?>" />
								</td><td>
									<select name="list<?php echo $establishment->id; ?>">
										<option value="1" selected="selected">Y</option>
										<option value="0" >N</option>
									</select>
								</td><td>
									<input type="checkbox" name="delete[]" value="<?php echo $establishment->id; ?>" />
								</td></tr>
								<?php }?>
								</table>
							
								<h2>UNLISTED RECORDS</h2>
								<table class="borderless">
								<th>SUBURB</th>
								<th>NAME</th>
								<th>ADDRESS</th>
								<th>TELEPHONE</th>
								<th>LIST</th>
								<th>DELETE</th>
								<?php 
								$establishments = Establishment::find_unlisted();
								foreach($establishments as $establishment)
								{
								?>
								<tr><td>
									<select name="suburb<?php echo $establishment->id; ?>">
										<option value="0">Select Suburb...</option>
									<?php 
										foreach($suburbs as $suburb)
										{	
											echo '<option value="'.$suburb->id;
											if($suburb->id = $establishment->suburbs_id) echo '" selected="selected';
											echo '">'.$suburb->suburb.'</option>';
										}
									?>
									</select>
								</td><td>
									<input type="text" size="20" name="name<?php echo $establishment->id;?>" value="<?php echo $establishment->name; ?>" />
								</td><td>
									<input type="text" size="30" name="address<?php echo $establishment->id; ?>" value="<?php echo $establishment->address; ?>" />
								</td><td>
									<input type="text" size="10" name="tel<?php echo $establishment->id; ?>" value="<?php echo $establishment->tel; ?>" />
								</td><td>
									<select name="list<?php echo $establishment->id; ?>">
										<option value="1">Y</option>
										<option value="0" selected="selected">N</option>
									</select>
								</td><td>
									<input type="checkbox" name="delete[]" value="<?php echo $establishment->id; ?>" />
								</td></tr>
								<?php }?>
								</table>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" /> &nbsp;<input type="reset" name="reset" value="Reset" />
							</div>
							
						</form>
						
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>