<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php if(!$session->is_logged_in()) {redirect_to("login.php");} ?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$firstname = trim($_POST['firstname']);
		$surname = trim($_POST['surname']);
		if($firstname == 'First Name') $firstname = "";
		if($surname == 'Surname') $surname = "";
		if($firstname == ""  && $surname == "")
		{
			$message = '<p class="red">PLEASE ENTER A FIRST NAME OR SURNAME.</p>';
		} else
		{
			$guides = Guide::find_by_name($firstname, $surname);
		}
	} else if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$language	= trim($_POST['language']);
		$category 	= trim($_POST['category']);
		$region 	= trim($_POST['region']);
		$type 		= trim($_POST['type']);
		$speciality	= trim($_POST['speciality']);
		$frompost 	= trim($_POST['from']);
		$topost		= trim($_POST['to']);
		$vehicle 	= trim($_POST['vehicle']);
		
		$search = '';
		if($language != 'none')
			$search .= ' JOIN guides_languages gl ON gl.guides_id=g.id AND gl.languages_id='.$language;
		if($category != 'all')
			$search .= ' JOIN guides_categories gc ON gc.guides_id=g.id AND gc.categories_id='.$category;
		if($region != 'all')
			$search .= ' JOIN guides_regions gr ON gr.guides_id=g.id AND gr.regions_id='.$region;
		if($type != 'all')
			$search .= ' JOIN guides_types gt ON gt.guides_id=g.id AND gt.types_id='.$type;
		if($speciality != 'all')
			$search .= ' JOIN guides_specialities gs ON gs.guides_id=g.id AND gs.specialities_id='.$speciality;
		if($vehicle != 'none')
			$search .= ' JOIN vehicles v ON v.guides_id=g.id AND v.capacity >='.$vehicle;
			
		$from_parts = explode('/', $frompost);
		if(is_numeric($from_parts[0]) && is_numeric($from_parts[0]) && is_numeric($from_parts[2]))
			$fromdate = checkdate($from_parts[1], $from_parts[0], $from_parts[2]);
		else $fromdate = false;
		
		$to_parts = explode('/', $topost);
		if(is_numeric($to_parts[0]) && is_numeric($to_parts[1]) && is_numeric($to_parts[2]))
			$todate = checkdate($to_parts[1], $to_parts[0], $to_parts[2]);
		else $todate = false;
			
		if($fromdate || $todate)
		{
			if($fromdate)
			{
				$from = date('Y-m-d', strtotime(str_replace('/', '-', $frompost)));
				if($todate == true)
				{
					$to= date('Y-m-d', strtotime(str_replace('/', '-', $topost)));
					if($to < $from) $to = $from;
				} else
				{
					$to = $from;
				}
			} else if($todate)
			{
				$to= date('Y-m-d', strtodate(str_replace('/', '-', $topost)));
				$from = $to;
			}
			$search .= ' WHERE g.id NOT IN (';
			$search .= "SELECT bd.guides_id FROM busy_days bd WHERE bd.date BETWEEN '".$from."' AND '".$to."') ";
		}	
		$guides = Guide::find_guides_by_search($search);	
	} else
	{
		$guides = Guide::find_all();
		$message = $session->message;
	}
		if(!isset($type)) 		$type = '';
		if(!isset($language))	$language = '';
		if(!isset($category))	$category = '';
		if(!isset($region))		$region = '';
		if(!isset($speciality))	$speciality = '';
		if(!isset($firstname))	$firstname = 'First Name';
		if(!isset($surname))	$surname = 'Surname';
		if(!isset($vehicle))	$vehicle = '';
?>

<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>

		
		<script language="JavaScript" type="text/javascript" >
		<!--
		function disableSelection(target){
			if (typeof target.onselectstart!="undefined") //IE route
				target.onselectstart=function(){return false}
			else if (typeof target.style.MozUserSelect!="undefined") //Firefox route
				target.style.MozUserSelect="none"
			else //All other route (ie: Opera)
				target.onmousedown=function(){return false}
			target.style.cursor = "default"
			}
		//-->
		</script>
		
		<script type="text/javascript" language="JavaScript">
			<!--
				function toggleLayer( whichLayer )
				{
				var elem, vis;
				if( document.getElementById ) // this is the way the standards work
				elem = document.getElementById( whichLayer );
				else if( document.all ) // this is the way old msie versions work
				elem = document.all[whichLayer];
				else if( document.layers ) // this is the way nn4 works
				elem = document.layers[whichLayer];
				vis = elem.style;
				// if the style.display value is blank we try to figure it out here
				if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
				vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
				vis.display = (vis.display==''||vis.display=='block')?'none':'block';
				} 
			//-->
		</script>

<?php if($session->is_admin_user() == false) { ?>
		<style>
			body{-webkit-user-select:none;
		-moz-user-select:none;
			}
		</style>
		
		<script type="text/javascript" language="JavaScript">
		function toggleLayer( whichLayer )
		{
		var elem, vis;
		if( document.getElementById ) // this is the way the standards work
		elem = document.getElementById( whichLayer );
		else if( document.all ) // this is the way old msie versions work
		elem = document.all[whichLayer];
		else if( document.layers ) // this is the way nn4 works
		elem = document.layers[whichLayer];
		vis = elem.style;
		// if the style.display value is blank we try to figure it out here
		if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
		vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
		vis.display = (vis.display==''||vis.display=='block')?'none':'block';
		} 
		</script>
<?php } ?>

		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />

<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
				
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
					<h1>TOURIST GUIDES</h1>
					
					<p>
						<a href="manage-guides.php">ALL GUIDES</a> &nbsp;|&nbsp;
						<a href="javascript:toggleLayer('fullsearch');">DETAILED SEARCH</a> &nbsp;|&nbsp;
						<a href="javascript:toggleLayer('namesearch');">SEARCH BY NAME</a>  &nbsp;|&nbsp;
						<a href="new-guide.php">NEW GUIDE</a>
					</p>
					
					<?php if($message != '') echo $message; ?>
								
					<div id="namesearch" >
						<div id="guidesearch">
							<h2>SEARCH BY NAME</h2>
							<form method="post" action="manage-guides.php">
								<input type=text" name="firstname" value="<?php echo $firstname; ?>" onfocus="this.value=''" size="20" />
								&nbsp;&nbsp;
								<input type=text" name="surname" value="<?php echo $surname; ?>" onfocus="this.value=''" size="20" />
								&nbsp;&nbsp;
								<input type="submit" name="submitname" value="Search" />
							</form>
						</div>
					</div>
								
					<div id="fullsearch" >
						<div id="guidesearch">		
							<form method="post" action="manage-guides.php">
								<div class="row">
									<h2>DETAILED SEARCH</h2>
									<select name="language">
										<option value="none">All Languages</option>
										<?php 
											$langs = Language::find_all();
											foreach($langs as $lang)
											{
												echo '<option value="'.$lang->id;
												if($lang->id == $language) echo '" selected="selected';
												echo '">'.$lang->language.'</option>';
											}
										?>
									</select>
									&nbsp;&nbsp;
									<select name="category">
										<option value="all">All Categories</option>
										<?php 
											$cats = Category::find_all();
											foreach($cats as $cat)
											{
												echo '<option value="'.$cat->id;
												if($cat->id == $category) echo '" selected="selected';
												echo '">'.$cat->category.'</option>';
											}
										?>
									</select>
									&nbsp;&nbsp;
									<select name="region">
										<option value="all">All Regions</option>
										<?php 
											$regs = Region::find_all();
											foreach($regs as $reg)
											{
												echo '<option value="'.$reg->id;
												if($reg->id == $region) echo '" selected="selected';
												echo '">'.$reg->region.'</option>';
											}
										?>
									</select>
									&nbsp;&nbsp;
									<select name="type">
										<option value="all">All Types</option>
										<?php 
											$typs = Type::find_all();
											foreach($typs as $typ)
											{
												if($typ->id <4)
												{
													echo '<option value="'.$typ->id;
													if($typ->id == $type) echo '" selected="selected';
													echo '">'.$typ->type.'</option>';
												}
											}
										?>
									</select>
									&nbsp;&nbsp;
									<select name="speciality">
										<option value="all">All Specialities</option>
										<?php 
											$specs = Speciality::find_all();
											foreach($specs as $spec)
											{
												echo '<option value="'.$spec->id;
												if($spec->id == $speciality) echo '" selected="selected';
												echo '">'.$spec->speciality.'</option>';
											}
										?>
									</select>
								</div>
								
								<div class="row">
									<p><b>AVAILABILITY </b></p> 
									
									<script>
										$(function() {
											$( "#datefrom" ).datepicker({
												dateFormat: 'dd/mm/yy',
												changeMonth: true,
												changeYear: true,
												showOtherMonths: true,
												selectOtherMonths: true
												});
										});
									</script>
									<input type="text" name="from" value="dd/mm/yyyy" id="datefrom" size="20" />
									
									&nbsp;<label>to</label>&nbsp;
								
									<script>
										$(function() {
											$( "#datepicker" ).datepicker({
												dateFormat: 'dd/mm/yy',
												changeMonth: true,
												changeYear: true,
												showOtherMonths: true,
												selectOtherMonths: true
												});
										});
									</script>
									<input type="text" name="to" value="dd/mm/yyyy" id="datepicker"  size="20" />
									&nbsp;&nbsp;
									<select name="vehicle">
										<option value="none">No Vehicle</option>
										<option value="1" <?php if($vehicle == 1) echo 'selected="selected"'; ?>>1 Passenger</option>
										<?php 
											for($i = 2; $i <20; $i++)
											{
												echo '<option value="'.$i;
												if($i == $vehicle) echo '" selected="selected';
												echo '">'.$i.' Passengers</option>';
											}
										?>
									</select>
								</div>
								
								<div class="row">
									<input type="submit" name="submit" value="Search" />
								</div>
							</form>
							
							
						</div>
					</div>
					
					<div class="guide_details">
						<h2><?php 
							if($_SERVER['REQUEST_METHOD'] == "POST")
								echo 'SEARCH RESULTS';
							else echo 'ALL GUIDES';
						?></h2>
					
					<?php if(!isset($guides) || empty($guides)) echo '<p class="red"><b>THERE ARE NO GUIDES TO DISPLAY</b></p>';
					else
					{?>	
						<table cellpadding="0">
							<tr>
								<th>Name</th>
								<th width="40px">Car Seats</th>
								<th>Next Tour</th>
								<th>Languages</th>
								<th>Categories</th>
								<th>Regions</th>
								<th>Groupings</th>
							</tr>
							
							<?php 
								foreach($guides as $guide)
								{
									$car = Vehicle::find_by_guide($guide->id);
									$busyday = BusyDay::find_next_guide_booking($guide->id);
									$glanguages = find_guide_languages($guide->id);
									$gcats = Category::find_by_guide($guide->id);
									$gregs = Region::find_by_guide($guide->id);
									$gspecs = Speciality::find_by_guide($guide->id);
									
									echo '<tr>';
									echo '<td><a class="more" href="guide-details.php?id='.$guide->id.'">';
									echo $guide->firstname.' '.$guide->surname.'</a></td>';
									echo '<td>';
									if($car) 
										echo $car->capacity;
									else echo 'None';
									echo '</td>';
									echo '<td>';
									if($busyday) echo $busyday->date;
									else echo 'None';
									echo '</td>';
									echo '<td><ul>';
									while($glanguage = mysql_fetch_array($glanguages))
									echo '<li>'.$glanguage['language'].' - '.$glanguage['name'].'<li>';
									echo '</ul></td>';
									echo '<td><ul>';
									foreach($gcats as $gcat) echo '<li>'.$gcat->category.'</li>';	
									echo '</ul></td>';
									echo '<td><ul>';
									foreach($gregs as $greg) echo '<li>'.$greg->region.'</li>';
									echo '</ul></td>';
									echo '<td><ul>';
									foreach($gspecs as $gspec) echo '<li>'.$gspec->speciality.'</li>';
									echo '</ul></td/>';
									echo '</tr>';
								}
							?>
						</table>
						
						<?php }?>
						<p>&nbsp;</p>
					</div>
						
					</div>
					
				</div>
				
			</div>
			
			<?php if(!$session->is_admin_user()):?>
			<script type="text/javascript">
			disableSelection(document.body) //disable text selection on entire body of page
			</script>
			<?php endif; ?>
			
<?php include_layout('footer-admin.php'); ?>

