<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");}

	$message = $session->message;
	
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		if(isset($_POST['delete']))
		{
			$deletestring = implode(', ', $_POST['delete']);
			$delets = explode(', ', $deletestring);
			foreach($delets as $delet)
			{
				$delmodel = VehicleModel::find_by_id($delet);
				$delmodel->delete();
			}
		}
		
		$models = VehicleModel::find_all();
		foreach($models as $model)
		{
			$model->vehicle_makes_id = trim($_POST['make'.$model->id]);
			$model->model = trim($_POST['model'.$model->id]);
			if($model->vehicle_makes_id != 0 && $model->model != "")
				$model->update();
			else $message .= '<p class="red">Could not update "'.$model->model.'". Make and model name must be provided.</p>';
		}
		
		for($j = 1; $j < 4; $j++)
		{
			if($_POST['newmake'.$j] != 0 && $_POST['newmodel'.$j] != "")
			{
				$make_id = trim($_POST['newmake'.$j]);
				$model = trim($_POST['newmodel'.$j]);
				$modelexists = VehicleModel::find_by_model($make_id, $model);
				if(!$modelexists)
				{
					$newmodel = new VehicleModel();
					$newmodel->model = $model;
					$newmodel->vehicle_makes_id = $make_id;
					$newmodel->create();
				} else 
				$message .= '<p class="red">Model called "'.$name.'" already exists.</p>';
			}
		}
	}
	?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>MANAGE VEHICLE MODELS</h1>
						
						<p><a href="manage-database.php">&laquo; BACK</a></p>
						
						<?php if($message != "") echo $message; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post" >
							
							<h2>NEW MODELS</h2>
							
							<table class="borderless">
								<th>MAKE</th>
								<th>MODEL</th>
								<?php 
								$makes = VehicleMake::find_all();
									for($i = 1; $i<4; $i++)
									{
								?>
									<tr><td>
										<select name="newmake<?php echo $i; ?>">
											<option value="0">Select Make...</option>
										<?php 
											foreach($makes as $make)
												echo '<option value="'.$make->id.'">'.$make->make.'</option>';
										?>
										</select>
									</td><td>
										<input type="text" size="20" name="newmodel<?php echo $i;?>" />
									</td></tr>
								<?php } ?>
							</table>
							
							<h2>EXISTING RECORDS</h2>
							<table class="borderless">
								<th>MAKE</th>
								<th>MODEL</th>
								<th>&nbsp;</th>
								<?php 
								$models = VehicleModel::find_all();
								foreach($models as $model)
								{
								?>
								<tr><td>
									<select name="make<?php echo $model->id;?>">
										<option value="0">Select Make...</option>
										<?php 
											foreach($makes as $make)
											{ 
												echo '<option value="'.$make->id;
												if($model->vehicle_makes_id == $make->id) echo '" selected="selected';
												echo '">'.$make->make.'</option>';
											}	
										?>
									</select>
								</td><td>
									<input type="text" size="20" name="model<?php echo $model->id; ?>" value="<?php echo $model->model; ?>" />
								</td><td>
									<input type="checkbox" name="delete[]" value="<?php echo $model->id; ?>" /> DELETE	
								</td></tr>
								<?php }?>
								</table>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" /> &nbsp;<input type="reset" name="reset" value="Reset" />
							</div>
							
						</form>
						
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>