<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$from_date = date('Y-m-d', strtotime(str_replace("/", "-", trim($_POST['from']))));
		$to_date = date('Y-m-d', strtotime(str_replace("/", "-", trim(trim($_POST['to'])))));
		$from = "'".$from_date."'";
		$to = "'".$to_date."'";
		$tours = Tour::find_set_tours_by_period($from, $to);
		$head = $from_date.' to '.$to_date;
		$extra = " AND t.start_date BETWEEN ".$from." AND ".$to;
	} else if(isset($_GET['period']))
	{
		$period = trim($_GET['period']);
		if($period == 'nextmonth')
		{
			$from = 'LAST_DAY(CURDATE()) +1';
			$to = 'LAST_DAY(CURDATE() + INTERVAL 1 MONTH)';
			$tours = Tour::find_set_tours_by_period($from, $to); 	
			$head = "NEXT MONTH'S";
			$extra = " AND t.start_date BETWEEN ".$from." AND ".$to;
		} elseif($period == 'lastmonth')
		{
			$from = 'LAST_DAY(CURDATE()) -1';
			$to = 'LAST_DAY(CURDATE() - INTERVAL 1 MONTH)';
			$tours = Tour::find_set_tours_by_period($from, $to); 	
			$head = "LAST MONTH'S";
			$extra = " AND t.start_date BETWEEN ".$from." AND ".$to;
		} elseif($period == 'year')
		{
			$from = "'".date("Y")."-01-01'";
			$to = "'".date("Y")."-12-31'";
			$tours = Tour::find_set_tours_by_period($from, $to); 	
			$head = "THIS YEAR'S";
			$extra = " AND YEAR(t.start_date) = YEAR(CURDATE())";
		} elseif($period == 'all')
		{
			$from = "'2010-11-01'";
			$to = "'2050-01-01'";
			$tours = Tour::find_set_tours();
			$head = "ALL";
			$extra = "";
		}
	} else
	{
		$current = 'active';
		$status = 'all';
		$time = ' MONTH(start_date) = MONTH(CURDATE())';
		
		$from = "LAST_DAY(CURDATE()- INTERVAL 1 MONTH) + 1";
		$to = "LAST_DAY(CURDATE())";
		$tours = Tour::find_set_tours_by_period(); 	
		$head = "THIS MONTH'S";
		$extra = "";
	}
	$count = count($tours);
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" language="JavaScript">
			function toggleLayer( whichLayer )
			{
				var elem, vis;
				if( document.getElementById ) // this is the way the standards work
				elem = document.getElementById( whichLayer );
				else if( document.all ) // this is the way old msie versions work
				elem = document.all[whichLayer];
				else if( document.layers ) // this is the way nn4 works
				elem = document.layers[whichLayer];
				vis = elem.style;
				// if the style.display value is blank we try to figure it out here
				if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
				vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
				vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
		</script>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />
		
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>MANAGE SET TOURS</h1>
						
						<?php if(isset($session->message) && $session->message != "") echo $session->message.'<br/>'; ?>
						
						<h2><?php echo $head; ?> SET TOURS</h2>
						<p>TOTAL: <?php echo $count; ?></p>
						
						<?php 
							$categories = Category::find_all();
							foreach($categories as $category)
							{
								echo '<h3>'.strtoupper($category->category).'</h3>';
								$services = Service::find_by_category_current_long($category->id);
								if($services)
								{
								?>
								<table>
									<tr>
										<th>Start Date</th>
										<th>Capacity</th>
										<th>Status</th>
										<th>Guide</th>
										<th>Language</th>
										<th>Enquiries</th>
										<th>&nbsp;</th>
									</tr>
								<?php 
									foreach($services as $service)
									{
										?>
										<tr><td colspan="7">
											<a href="edit-tour.php?id=<?php echo $service->id; ?>">
												<?php echo strtoupper($service->title); ?>
											</a>
										</td></tr>
										
										
										<?php
										$cat_tours = Tour::find_set_tours_by_service($service->id, $from, $to);
										foreach ($cat_tours as $cat_tour)
										{
											$guide = Guide::find_by_id($cat_tour->guides_id);
											$language = Language::find_by_id($cat_tour->languages_id);
											$enquiries = Enquiry::find_by_tour($cat_tour->id);
											$tour_status = TourStatus::find_by_id($cat_tour->tours_status_id);
										?>
											<tr>
												<td><?php echo $cat_tour->start_date; ?></td>
												<td><?php echo $cat_tour->capacity; ?></td>
												<td><?php echo $tour_status->tour_status; ?></td>
												<td><?php if($guide)echo $guide->firstname.' '.$guide->surname;
													else echo 'No guide assigned yet.'; 
													?></td>
												<td><?php echo $language->language; ?></td>
												<td><?php foreach($enquiries as $enquiry) 
													echo '<a href="edit-enquiry.php?id='.$enquiry->id.'">'.$enquiry->reference.'('.$enquiry->no_people.')</a>'; ?>
												</td>
												<td><a href="tour-details.php?id=<?php echo $cat_tour->id; ?>">+ Details</a></td>
											</tr>
										<?php 
										}
										echo '</table>';
									}
								}
								echo '<p><a href="new-tour.php?cat='.$category->id.'" class="plain">+ Add new "'.$category->category.'" tour</a></p>';
							}
						?>
												
						<div class="row">
							<a href="manage-tours.php">THIS MONTH</a> &nbsp;|&nbsp;
							<a href="manage-tours.php?period=nextmonth">NEXT MONTH</a> &nbsp;|&nbsp;
							<a href="manage-tours.php?period=lastmonth">LAST MONTH</a> &nbsp;|&nbsp;
							<a href="manage-tours.php?period=year">THIS YEAR</a> &nbsp;|&nbsp;
							<a href="manage-tours.php?period=all">VIEW ALL</a> &nbsp;|&nbsp;
							<a href="javascript:toggleLayer('dates');">MORE OPTIONS</a>
						</div>
						
						<div id="dates">
							<form action="manage-tours.php" method="post">
								<div class="row">
									<div class="details">
										<label>From</label><br/>
										<script>
											$(function() {
												$( "#datefrom" ).datepicker({
													dateFormat: 'dd/mm/yy'
													});
											});
										</script>
										<div class="calendar">
											<input type="text" name="from" value="dd/mm/yyyy" id="datefrom" size="20" />
										</div>
										&nbsp;&nbsp;
									</div>
									<div class="details">
										<label>To</label><br/>
										<script>
											$(function() {
												$( "#datepicker" ).datepicker({
													dateFormat: 'dd/mm/yy'
													});
											});
										</script>
										<div class="calendar">
										<input type="text" name="to" value="dd/mm/yyyy" id="datepicker"  size="20" />
										
										
										&nbsp;&nbsp;
										</div>
										
									</div>
									
								</div>
								
								<div class="row">
									<p><label>Show types of tours: </label></p> 
									<input type="radio" name="current" value="all" <?php if($current = 'all') echo 'checked="checked"'; ?> /> All
									<input type="radio" name="current" value="active" <?php if($current = 'active') echo 'checked="checked"'; ?>/> Active 
									<input type="radio" name="current" value="inactive" <?php if($current = 'inactive') echo 'checked="checked"'; ?>/> Inactive
								</div>
								
								<div class="row">
									<p><label>Select tour status: </label></p> 
									<input type="radio" name="status" value="all" <?php if($status = 'all') echo 'checked="checked"'; ?> /> All
									<input type="radio" name="status" value="scheduled" <?php if($status = 'scheduled') echo 'checked="checked"'; ?>/> Scheduled 
									<input type="radio" name="status" value="completed" <?php if($status = 'completed') echo 'checked="checked"'; ?>/> Completed
									<input type="radio" name="status" value="cancelled" <?php if($status = 'cancelled') echo 'checked="checked"'; ?>/> Cancelled
								</div>
								
								<div class="row">
									<br/>
									<input type="submit" name="submit" value="GO" />
								</div>
							</form>
						</div>
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>