<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	$message = $session->message;
	?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$status = trim($_POST['status']);
		if($status == 'all') $tour_extra = "";
		else if($status == 'scheduled') $tour_extra = ' AND tours_status_id=1';
		else if($status == 'completed') $tour_extra = ' AND tours_status_id=2';
		else if($status == 'cancelled') $tour_extra = ' AND tours_status_id=3';
		
		$current = trim($_POST['current']);
		if($current == 'active') $service_extra = ' AND current=1';
		else if($current == 'inactive') $service_extra = ' AND current=0';
		else $service_extra = "";
		
		$from = date('Y-m-d', strtotime(str_replace("/", "-", trim($_POST['from']))));
		$to = date('Y-m-d', strtotime(str_replace("/", "-", trim(trim($_POST['to'])))));
		
		if($_POST['from'] == 'dd/mm/yyyy' || $_POST['to'] == 'dd/mm/yyyy')
		{
			$tour_extra .= ' AND MONTH(start_date) = MONTH(CURDATE())';
			$head = "THIS MONTH's";
		} else
		{
			$tour_extra .= " AND start_date BETWEEN '".$from."' AND '".$to."'";
			$head = $from.' to '.$to;
		}
	} else if(isset($_GET['period']))
	{
		$status = trim($_GET['status']);
		if($status = 'all') $tour_extra = "";
		else if($status = 'scheduled') $tour_extra = ' AND tours_status_id=1';
		else if($status = 'completed') $tour_extra = ' AND tours_status_id=2';
		else if($status = 'cancelled') $tour_extra = ' AND tours_status_id=3';
		
		$current = trim($_GET['current']);
		if($current == 'current') $service_extra = ' AND current=1';
		else if($current == 'current') $service_extra = ' AND current=0';
		else $service_extra = "";
		
		$period = trim($_GET['period']);
		if($period == 'nextmonth')
		{
			$tour_extra .= ' AND start_date BETWEEN LAST_DAY(CURDATE()) +1 AND LAST_DAY(CURDATE() + INTERVAL 1 MONTH)';
			$head = "NEXT MONTH'S";
		} elseif($period == 'lastmonth')
		{
			$tour_extra .= ' AND start_date BETWEEN (LAST_DAY(CURDATE() - INTERVAL 2 MONTH) +1) AND LAST_DAY(CURDATE() - INTERVAL 1 MONTH)';
			$head = "LAST MONTH'S";
		} elseif($period == 'year')
		{
			$tour_extra .= " AND YEAR(start_date) = YEAR(CURDATE())";
			$head = "THIS YEAR'S";
		} elseif($period == 'all')
		{
			$head = "ALL";
		}
	} else // this month
	{
		if(isset($_GET['status'])) 
		{
			$status = trim($_GET['status']);
			if($status = 'all') $tour_extra = "";
			else if($status = 'scheduled') $tour_extra = ' AND tours_status_id=1';
			else if($status = 'completed') $tour_extra = ' AND tours_status_id=2';
			else if($status = 'cancelled') $tour_extra = ' AND tours_status_id=3';
		} else 
		{
			$status = 'all';
			$tour_extra = '';
		}
		if(isset($_GET['current'])) 
		{
			$current = trim($_POST['current']);
			if($current == 'active') $service_extra = ' AND current=1';
			else if($current == 'inactive') $service_extra = ' AND current=0';
			else $service_extra = "";
		} else
		{
			$current = 'active';
			$service_extra = ' AND current=1';
		}
		$tour_extra .= ' AND MONTH(start_date) = MONTH(CURDATE())';
		$head = "THIS MONTH'S";
	}
	$tours = Tour::find_set_tours($tour_extra); 
	$count = count($tours);
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" language="JavaScript">
			function toggleLayer( whichLayer )
			{
				var elem, vis;
				if( document.getElementById ) // this is the way the standards work
				elem = document.getElementById( whichLayer );
				else if( document.all ) // this is the way old msie versions work
				elem = document.all[whichLayer];
				else if( document.layers ) // this is the way nn4 works
				elem = document.layers[whichLayer];
				vis = elem.style;
				// if the style.display value is blank we try to figure it out here
				if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
				vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
				vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
		</script>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />
		
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>MANAGE SET TOURS</h1>
						
						<?php if($message != "") echo $message; ?>
						
						<h2><?php echo $head; ?> SET TOURS</h2>
						<p>TOTAL: <?php echo $count; ?></p>
						
						<?php 
							$categories = Category::find_all();
							foreach($categories as $category)
							{
								echo '<h3>'.strtoupper($category->category).'</h3>';
								$services = Service::find_set_tours_by_category($category->id, $service_extra);
								if($services)
								{
								?>
								<table>
									<tr>
										<th>Start Date</th>
										<th>End Date</th>
										<th>Capacity</th>
										<th>Status</th>
										<th>Guide</th>
										<th>Language</th>
										<th>Enquiries</th>
										<th>&nbsp;</th>
									</tr>
								<?php 
									foreach($services as $service)
									{
										?>
										<tr><td colspan="8">
											<a href="edit-tour.php?id=<?php echo $service->id; ?>">
												<?php echo strtoupper($service->title); ?>
											</a>
										</td></tr>
										
										
										<?php
										$cat_tours = Tour::find_by_service($service->id, $tour_extra);
										foreach ($cat_tours as $cat_tour)
										{
											$guide = Guide::find_by_id($cat_tour->guides_id);
											$language = Language::find_by_id($cat_tour->languages_id);
											$enquiries = Enquiry::find_by_tour($cat_tour->id);
											$tour_status = TourStatus::find_by_id($cat_tour->tours_status_id);
											$end_date = date('Y-m-d', (strtotime($cat_tour->start_date) + (86400 * $service->duration)))
										?>
											<tr>
												<td><?php echo $cat_tour->start_date; ?></td>
												<td><?php echo $end_date; ?></td>
												<td><?php echo $cat_tour->capacity; ?></td>
												<td><?php echo $tour_status->tour_status; ?></td>
												<td><?php if($guide)echo $guide->firstname.' '.$guide->surname;
													else echo 'No guide assigned yet.'; 
													?></td>
												<td><?php echo $language->language; ?></td>
												<td><?php foreach($enquiries as $enquiry) 
													echo '<a href="edit-enquiry.php?id='.$enquiry->id.'">'.$enquiry->reference.'('.$enquiry->no_people.')</a>'; ?>
												</td>
												<td><a href="tour-details.php?id=<?php echo $cat_tour->id; ?>">+ Details</a></td>
											</tr>
										<?php 
										}
									}
									echo '</table>';
								}
								echo '<p><a href="new-tour.php?cat='.$category->id.'" class="plain">+ Add new "'.$category->category.'" tour</a></p>';
								echo '<p class="catdivide">&nbsp;</p>';
							}
						?>
												
						<div class="row">
							<a href="manage-tours.php?status=<?php echo $status;?>&current=<?php echo $current;?>">THIS MONTH</a> &nbsp;|&nbsp;
							<a href="manage-tours.php?period=nextmonth&status=<?php echo $status;?>&current=<?php echo $current;?>">NEXT MONTH</a> &nbsp;|&nbsp;
							<a href="manage-tours.php?period=lastmonth&status=<?php echo $status;?>&current=<?php echo $current;?>">LAST MONTH</a> &nbsp;|&nbsp;
							<a href="manage-tours.php?period=year&status=<?php echo $status;?>&current=<?php echo $current;?>">THIS YEAR</a> &nbsp;|&nbsp;
							<a href="manage-tours.php?period=all&status=<?php echo $status;?>&current=<?php echo $current;?>">VIEW ALL</a> &nbsp;|&nbsp;
							<a href="javascript:toggleLayer('dates');">MORE OPTIONS</a>
						</div>
						
						<div id="dates">
							<form action="manage-tours.php" method="post">
								<div class="row">
									<div class="details">
										<label>From</label><br/>
										<script>
											$(function() {
												$( "#datefrom" ).datepicker({
													dateFormat: 'dd/mm/yy'
													});
											});
										</script>
										<div class="calendar">
											<input type="text" name="from" value="dd/mm/yyyy" id="datefrom" size="20" />
										</div>
										&nbsp;&nbsp;
									</div>
									<div class="details">
										<label>To</label><br/>
										<script>
											$(function() {
												$( "#datepicker" ).datepicker({
													dateFormat: 'dd/mm/yy'
													});
											});
										</script>
										<div class="calendar">
										<input type="text" name="to" value="dd/mm/yyyy" id="datepicker"  size="20" />
										
										
										&nbsp;&nbsp;
										</div>
										
									</div>
									
								</div>
								
								<div class="row">
									<p><label>Show types of tours: </label></p> 
									<input type="radio" name="current" value="all" <?php if($current == 'all') echo 'checked="checked"'; ?> /> All
									<input type="radio" name="current" value="active" <?php if($current == 'active') echo 'checked="checked"'; ?>/> Active 
									<input type="radio" name="current" value="inactive" <?php if($current == 'inactive') echo 'checked="checked"'; ?>/> Inactive
								</div>
								
								<div class="row">
									<p><label>Select tour status: </label></p> 
									<input type="radio" name="status" value="all" <?php if($status == 'all') echo 'checked="checked"'; ?> /> All
									<input type="radio" name="status" value="scheduled" <?php if($status == 'scheduled') echo 'checked="checked"'; ?>/> Scheduled 
									<input type="radio" name="status" value="completed" <?php if($status == 'completed') echo 'checked="checked"'; ?>/> Completed
									<input type="radio" name="status" value="cancelled" <?php if($status == 'cancelled') echo 'checked="checked"'; ?>/> Cancelled
								</div>
								
								<div class="row">
									<br/>
									<input type="submit" name="submit" value="GO" />
								</div>
							</form>
						</div>
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>