<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php if(!$session->is_logged_in()) {redirect_to("login.php");} ?>
<?php 
	if(!isset($_GET['guide']))
	{
		$session->message("No guide id was provided.");
		redirect_to('guide-list.php');
	}  else
	{
		$guide_id = mysql_prep($_GET['guide']);
		$guide = Guide::find_by_id($guide_id);
		$frompost = trim($_GET['from']);
		$date = date('d/m/Y', strtotime($frompost));
		$message = $session->message;
		
		if(isset($_POST['submitext']))
		{
			$fromdate = trim($_POST['from']);
			$todate = trim($_POST['to']);
			$phpfrom = strtotime(str_replace('/', '-', $fromdate));
			$phpto = strtotime(str_replace('/', '-', $todate));
			$diff = ($phpto-$phpfrom)/86400;
			for($k = 0; $k <= $diff; $k++)
			{
				$phpbusydate = $phpfrom + ($k * 86400);
				$busydate = date('Y-m-d', $phpbusydate);
				$newday = new BusyDay();
				$newday->date = $busydate;
				$newday->guides_id = $guide_id;
				$newday->tours_id = 0;
				$newday->status_id = 3;
				$newday->create();
			}
			$session->message('<p class="green">Unavailable dates have been scheduled.</p>');
			redirect_to('guide-details.php?id='.$guide_id);
		} else if(isset($_POST['submit']))
		{
			$ref = trim(strip_tags($_POST['ref']));
			$enquiry = Enquiry::find_by_reference($ref);
			if($enquiry->tours_id == 0)
			{	
				$session->message('<p class="red">There are no tour details for this enquiry.</p>');
				redirect_to('guide-details.php?id='.$guide_id);
			} else
			{
				$tour = Tour::find_by_id($enquiry->tours_id);
				$tour->guides_id = $guide_id;
				$tour->update();
				$tourdays = BusyDay::find_by_tour($tour->id);
				if(empty($tour_days))
				{
					$session->message('<p class="green">There are no tour dates set for this enquiry. Guide has been assign to tour.</p>');
					redirect_to('guide-details.php?id='.$guide_id);
				} else
				{
					if($enquiry->status_id == 1)
					{
						$stat = 2;
						$enquiry->status_id = 2;
						if($enquiry->update())
						{
							$enqstatus = new EnquiryStatus();
							$enqstatus->enquiries_id = $enquiry->id;
							$enqstatus->status_id = 2;
							$enqstatus->update();
						}
					}
					foreach($tour_days as $tour_day)
					{
						$tour_day->guides_id = $guide_id;
						if(isset($stat)) $tour_day->status = 2;
						$tour_day->update();
					}
					$session->message('<p class="green">Guide has been assigned to tour and calendar updated accordingly.</p>');
					redirect_to('guide-details.php?id='.$guide_id);
				}
			}
		}
	}
?>

<?php include_layout('html.php'); ?>

		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" src="/ctgc/admin/ckeditor/ckeditor.js"></script>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />

<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
					<h1>ADD BOOKING FOR: <?php echo strtoupper($guide->firstname.' '.$guide->surname); ?></h1>
					
					<p><a href="guide-details.php?id=<?php echo $guide_id; ?>">&laquo; BACK</a></p>
					
					<?php if($message != "") echo $message; ?>
					
					<div class="guide_details">
					
						<h2>ENQUIRY REFERENCE</h2>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post" >
						
							<p>
								<input type="text" name="ref" size="10" value="<?php // echo $ref; ?>" />
								<input type="submit" name="submit" value="Submit" />
							</p>
							<p>&nbsp;OR</p>
						</form>
					
						<h2>UNAVAILABLE DAYS</h2>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post" >
							<div class="row">
								<div class="calendar">Start Date:<br/>
									<script>
										$(function() {
											$( "#datefrom" ).datepicker({
												dateFormat: 'dd/mm/yy',
												changeMonth: true,
												changeYear: true,
												showOtherMonths: true,
												selectOtherMonths: true
												});
										});
									</script>
									<input type="text" name="from" value="<?php echo $date; ?>" id="datefrom"  size="20" />&nbsp;&nbsp;
								</div>
								
								<div class="calendar">End Date:<br/>
									<script>
										$(function() {
											$( "#dateto" ).datepicker({
												dateFormat: 'dd/mm/yy',
												changeMonth: true,
												changeYear: true,
												showOtherMonths: true,
												selectOtherMonths: true
												});
										});
									</script>
									<input type="text" name="to" value="<?php echo $date; ?>" id="dateto"  size="20" />&nbsp;&nbsp;
								</div>
							
								<div class="calendar">
									<p><input type="submit" name="submitext" value="Submit" /></p>
								</div>
							</div>
						</form>
						
						</div>
					</div>
				</div>
				
			</div>
			
			<?php if(!$session->is_admin_user()):?>
				<script type="text/javascript">
				disableSelection(document.body) //disable text selection on entire body of page
				</script>
			<?php endif; ?>
			
<?php include_layout('footer-admin.php'); ?>
