<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	if(!isset($_GET['service']))
	{
		$session->message('<p class="red">A tour/service must be selected to proceed.</p>');
		redirect_to('select-service.php');
	} else
	{
		$service_id = trim($_GET['service']);
		$service = Service::find_by_id($service_id);
		
		if($_SERVER['REQUEST_METHOD'] == "POST")
		{
			$firstname 		= trim(strip_tags($_POST['firstname']));
			$surname 		= trim(strip_tags($_POST['surname']));
			$country		= trim(strip_tags($_POST['country']));
			$other_country	= trim(strip_tags($_POST['other_country']));
			if($country == 'none')
			{
				if($other_country != '')
				{
					$coun = new Country();
					$coun->country = $other_country;
					$coun->create();
					$country = $coun->id;
				}
			}
			$email 			= trim(strip_tags($_POST['email']));
			$tel 			= trim(strip_tags($_POST['tel']));
			$contact 		= trim(strip_tags($_POST['contact']));
			if($_POST['date'] == "" || $_POST['date'] == 'dd/mm/yyyy')
			{
				$date = "";
			} else
			{
				$date			= date('Y-m-d', strtotime((str_replace('/','-', strip_tags($_POST['date'])))));
			}
			$people			= trim(strip_tags($_POST['people']));
			$language		= trim(strip_tags($_POST['language']));
			$requirements	= trim(strip_tags($_POST['requirements']));
			$establishment	= trim(strip_tags($_POST['establishment']));
			$estname		= trim(strip_tags($_POST['estname']));
			$address		= trim(strip_tags($_POST['address']));
			$esttel			= trim(strip_tags($_POST['esttel']));
			$estregion		= trim(strip_tags($_POST['estregion']));
			$comments		= trim(strip_tags($_POST['comments']));
			$coord			= trim(strip_tags($_POST['coord']));
			$method			= trim(strip_tags($_POST['method']));
			$status			= trim(strip_tags($_POST['status']));
			
			if($establishment == 'other' && $esttel != "" && $address != "" && $estregion != 'none')
			{
				$est = new Establishment();
				if($estname == "")
				{
					$estname = "private accommodation";
				}
				$est->name = $estname;
				$est->address = $address;
				$est->tel = $esttel;
				$est->list = 0;
				$est->regions_id = $estregion;
				$est->create();
				$establishment = $est->id;
			}
			
			$message = "";
			//	Check required fields 
			
			$labels = array( 
			'firstname'=>"First Name",
			'surname'=>"Surname",
			'email'=>'Email address',
			'tel'=>'Phone Number',
			'contact'=>'Contact Method',
			'country'=>'Country',
			'other_country'=>'Country',
			'service'=>'Service Selection',
			'date'=>'Departure date',
			'people'=>'Number of people',
			'language'=>'Preferred Language',
			'requirements'=>'Special Requirements',
			'establishment'=>'Select local address from list or complete all details for other local address',
			'estname'=>'Establishment Name',
			'address'=>'Establishment Address',
			'estregion'=>'Establishment Region',
			'esttel'=>'Establishment Phone Number',
			'comments'=>'comments',
			'coord'=>'Tour co-ordinator'
			);
			
			foreach($_POST as $field=>$value)
			{
				if($field == 'firstname' || $field == 'surname' || $field == 'email' || $field == 'tel')
				{
					if(empty($_POST[$field]) || ($field == 'language' && $value == 'none') || ($field == 'date' && ($value == 'dd/mm/yyyy' || $value == "")))
					{
						$blanks[$field] = "blank";
					}
				}  else if($field == 'country' && $value == 'none')
				{
					if($_POST['other_country'] == "")
					{
						$blanks[$field] = "blank";
					}
				}else if(($field == 'service' || $field == 'people' || $field == 'language') && $value == 'none')
				{
					$blanks[$field] = "blank";
				} else if($field == 'establishment' && ($value == 'none' || $value == 'other'))
				{
					if($estname == "" || $address == "" || $esttel == "" || $estregion == "none")
					{
						$blanks[$field] = "blank";
					}
				}
			}
			
			if(!empty($blanks))
			{
				if(sizeof($blanks)>0)
				{
					$message .= "<p class=\"red\">ONE OR MORE OF THE REQUIRED FIELDS ARE BLANK.<br/>Please enter the following information:<br>";
					foreach ($blanks as $field => $value)
					{
						$message .= "&nbsp;&nbsp;&nbsp;{$labels[$field]}<br/>";
					}
					$message .= "</p>";
				}
			} else
			{	
				// Create tour, client, new enquiry & ref
				$tour = new Tour();
				$tour->start_date 	= $date;
				$tour->capacity = $people;
				$tour->services_id 	= $service_id;
				$tour->guides_id = "";
				$tour->languages_id = $language;
				if($tour->create())
				{
					$client = new Client();
					$client->firstname 					= $firstname;
					$client->surname 					= $surname;
					$client->countries_id				= $country;
					$client->languages_id				= $language;
					$client->tel 						= $tel;
					$client->email 						= $email;
					$client->communication_methods_id 	= $contact;
					$client->establishments_id			= $establishment;
					if($client->create())
					{
						$method_tag = EnquiryMethod::find_by_id($method);
						$enquiry = new Enquiry();
						$maxid = get_max_id('enquiries');
						$enquiry->reference				= ($maxid + 1001).$method_tag->tag;
						$enquiry->created				= date('Y-m-d h:i:s', time());
						$enquiry->no_people				= $people;
						$enquiry->status 				= $status;
						$cost 							= $service->price * $people;
						$enquiry->total_cost 			= $cost;
						$enquiry->deposit_now			= $cost/100*$service->deposit; 
						$enquiry->clients_id 			= $client->id;
						$enquiry->tours_id 				= $tour->id;
						$enquiry->enquiry_methods_id 	= $method;
						$enquiry->coordinators_id		= $coord;
						$enquiry->create();
						
						// Need to create enquiry busy days entry/s
						for($k = 0; $k < $service->duration; $k++)
						{
							$busy_day = new BusyDay();
							$busy_day->guides_id = "";
							$busy_day->tours_id = $tour->id;
							$busy_day->status_id = 1;
							$busy_day->date = date('Y-m-d', (strtotime($date) + ($k * 86400)));
							$busy_day->create();
						}
						
						// Add Enquiries status 
						{
							$enquiries_status = new EnquiryStatus();
							$enquiries_status->enquiries_id = $enquiry->id;
							$enquiries_status->status_id = 1;
							$enquiries_status->create();
							if($status != 1)
							{
								$enquiries_stat = new EnquiryStatus();
								$enquiries_stat->enquiries_id = $enquiry->id;
								$enquiries_stat->status_id = $status;
								$enquiries_stat->create();
							}
						}
					}
				}
				
				// Get all text info for email
				$cm = CommunicationMethod::find_by_id($contact);
				$l = Language::find_by_id($language);
				$c = Country::find_by_id($country);
				$es = Establishment::find_by_id($establishment);
				$esreg = Suburb::find_by_id($es->suburbs_id);
				
				$emessage = '<b>CLIENT DETAILS</b><br/>';
				$emessage .= '<table style=" font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;" cellpadding="5">';
				$emessage .= '<tr><td>NAME: </td><td>'.$firstname.' '.$surname.'</td></tr>';
				$emessage .= '<tr><td>EMAIL ADDRESS: </td><td>'.$email.'</td></tr>';
				$emessage .= '<tr><td>PHONE NUMBER: </td><td>'.$tel.'</td></tr>';
				$emessage .= '<tr><td>PREFERRED CONTACT METHOD: </td><td>'.$cm->name.'</td></tr>';
				$emessage .= '<tr><td>LANGUAGE: </td><td>'.$l->language.'</td></tr>';
				$emessage .= '<tr><td>COUNTRY OF ORIGIN: </td><td>'.$c->country.'</td></tr>';
				$emessage .= '<tr><td>LOCAL ADDRESS:  </td><td>'.$es->name.' - '.$es->address.', '.$esreg->suburb.', TEL: '.$es->tel.'</td></tr>';
				$emessage .= '<tr><td>SPECIAL REQUIREMENTS:  </td><td>';
				if($requirements != "none")
				{
					$r = SpecialRequirement::find_by_id($requirements);
					$emessage .= $r->name;
				} else
				{
					$emessage .= 'NO';
				}
				$emessage .= '</td></tr></table><br/>';
				
				$emessage .= '<b>TOUR DETAILS</b><br/>';
				$emessage .= '<table style=" font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;" cellpadding="5">';
				$emessage .= '<tr><td>TYPE OF TOUR: </td><td>'.$service->title.'</td></tr>';
				$emessage .= '<tr><td>STARTING ON: </td><td>'.$date.'</td></tr>';
				$emessage .= '<tr><td>DURATION (DAYS): </td><td>'.$service->duration.'</td></tr>';
				$emessage .= '<tr><td>NUMBER OF PEOPLE: </td><td>'.$people.'</td></tr></table>';
				if($comments != '')
				{
					$emessage .= 'COMMENTS: <br/><br/>'.$comments.'<br/>';
					$note = new Note();
					$note->details = $comments;
					$note->users_id = $session->user_id;
					$note->create();
					
					$enq_note = new EnquiryNote();
					$enq_note->notes_id = $note->id;
					$enq_note->enquiries_id = $enquiry->id;
					$enq_note->create();
				}
				
				$error_message = "";
				
				if($people > 7)
				{
					$give_ref = "yes";
				} 
				if($requirements != 'none')
				{
					$give_ref = "yes";
				}
				
				if(!isset($give_ref) || $give_ref != 'yes')
				{
					// Check for guide with vehicle
					$guidefound = Guide::find_for_tour($tour->id);
					
					if(!empty($guidefound))
					{
						$tour->guides_id = $guidefound->id;
						$tour->update();
						
						if($status ==1)
						{
							$enquiry->status = 2;
							$enquiry->update();
						} 
						
						$enqstatus = new EnquiryStatus();
						$enqstatus->enquiries_id = $enquiry->id;
						$enqstatus->status_id = $enquiry->status;
						$enqstatus->create();
						
						$bds = BusyDay::find_by_tour($tour->id);
						foreach($bds as $bd)
						{
							$bd->guides_id 	= $guidefound->id;
							$bd->status		= $enquiry->status;
							$bd->update();
						}
						
						$vehicle = Vehicle::find_by_guide($guidefound->id);
						$tours_car = new TourVehicle();
						$tours_car->tours_id = $tour->id;
						$tours_car->vehicles_id = $vehicle->id;
						$tours_car->create();
					} else
					{
						$error_message .= '<p class="green">System was unable to find an available guide at this time.</p>';
						$give_ref = "yes";
					}
				}
				
				// send email								
				$to 		= "info@freshweb.co.za"; // coordinator
				$subject	= $enquiry->reference." - Website Boooking Enquiry";
				$headers	= "From: ".$email."\r\n";
				$headers	.= "Reply-To: ".$email."\r\n";
				$headers	.= "MIM-Version: 1.0\r\n";
				$headers	.= "Content-Type: text/html; charset=ISO-8859-1\r\n";
				
				$email_body	= '<html><body style="font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;">';
				$email_body .= '<h1>'.$enquiry->reference.'</h1>';
				$email_body	.= $emessage;
				$email_body	.= '</body></html>';
				
				$mailsend = mail($to, $subject, $email_body, $headers);
				
				$client_message = '<p class="green">Enquiry has been created.</p>';
				if($error_message != "") $client_message .= $error_message;
				$session->message($client_message);
				redirect_to('select-tour-guide.php?tour='.$tour->id);
			}
		} else
		{
			$user = User::find_by_id($session->user_id);
			$coord			= $user->coordinators_id;
			$method			= 2;
			$status			= 1;
			$firstname 		= "";
			$surname 		= "";
			$country		= "";
			$other_country 	= "";
			$email 			= "";
			$tel 			= "";
			$contact 		= "1";
			$date			= 'dd/mm/yyyy';
			$people			= "";
			$language		= "";
			$requirements	= "";
			$establishment	= "";
			$estname		= "private accommodation";
			$address		= "";
			$esttel			= "";
			$estregion		= "";
			$comments		= "";
		}
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" language="JavaScript">
			function toggleLayer(whichLayer)
			{
				var elem, vis;
				if( document.getElementById ) // this is the way the standards work
				elem = document.getElementById( whichLayer );
				else if( document.all ) // this is the way old msie versions work
				elem = document.all[whichLayer];
				else if( document.layers ) // this is the way nn4 works
				elem = document.layers[whichLayer];
				vis = elem.style;
				// if the style.display value is blank we try to figure it out here
				if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
				vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
				vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
		</script>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>NEW ENQUIRY - <?php echo strtoupper($service->title); ?></h1>
						
						<?php if(isset($message) && $message != "") echo $message; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post">
							
							<div class="row">
								<div class="label">Co-ordinator</div>
								<select name="coord">
								<?php 
									$coordins = Coordinator::find_all();
									foreach($coordins as $coordin)
									{
										echo '<option value="'.$coordin->id;
										if($coord == $coordin->id) echo '" selected="selected';
										echo '">'.$coordin->name.'</option>';
									}
								?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Enquiry Method</div>
								<select name="method">
								<?php 
									$meths = EnquiryMethod::find_all();
									foreach($meths as $meth)
									{
										echo '<option value="'.$meth->id;
										if($meth->id == $method) echo '" selected="selected';
										echo '">'.$meth->method.'</option>';
									}
								?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Enquiry Status</div>
								<select name="status">
								<?php 
									$stats = Status::find_all();
									foreach($stats as $stat)
									{
										echo '<option value="'.$stat->id;
										if($stat->id == $status) echo '" selected="selected';
										echo '">'.$stat->status.'</option>';
									}
								?>
								</select>
							</div>
							
							<?php include_layout('enquiry-form.php'); ?>
						
					</div>
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>