<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	$message = $session->message;
	
	if(isset($_GET['cat']))
	{
		$id = trim($_GET['cat']);
		$category = Category::find_by_id($id);
		$type = trim($_GET['type']);
	} else
	{
		$session->message("No category ID was provided.");
		redirect_to('manage-listings.php');
	}
	?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$title = trim($_POST['title']);
		$intro = trim($_POST['intro']);
		$details = trim($_POST['details']);
		$duration = trim($_POST['duration']);
		$price = trim($_POST['price']); // check only number
		$deposit = trim($_POST['deposit']);
		$region = trim($_POST['region']);
		$othregion = trim($_POST['othregion']); // error if region = none and othregion = ""
		$position = trim($_POST['position']);
		if(!$type) $type = 1;
	
		//Check for errors
		$error = "";
		if($title == "")
		{
			$error .= "Title can not be blank. Please add a title.<br/>";
		}
		if(!ctype_digit($price))
		{
			$error .= "Only numbers are accepted for price. Please re-enter the price.<br/>";
		}
		if(!ctype_digit($deposit))
		{
			$error .= "Only numbers are accepted for deposit percentage. Please re-enter the amount.<br/>";
		}
		if($region == 'none' && $othregion == "")
		{
			$error .= "No region was selected. Please select a region or enter a new region name.<br/>";
		}
		
		if($error != "")
		{
			$message = '<p class="red">There are errors.<br/>';
			$message .= $error;
			$message .= '</p>';
		} else
		{	
			//Check for duplicate page name
			$pagename = strtolower(str_replace("-&", "", str_replace(" ", "-", str_replace("'", "", trim($title))))).'-tours.html';
			$page = Page::find_by_pagename($pagename);
			$serv = Service::find_by_pagename($pagename);
			if(!empty($page) || !empty($serv))
			{
				$message = "A page with the same name already exists. Please enter a different title.";
			} else
			{
				$service = new Service();
				
				$service->pagename = $pagename;
				$service->title = $title;
				$service->intro = $intro;
				$service->details = $details;
				$service->duration = $duration;
				$service->price = $price;
				$service->deposit = $deposit;
				$service->position = $position;
				$service->current = 1;
				if($othregion != "")
				{
					$reg_exist = Region::find_by_region($othregion);
					if(!$reg_exist)
					{
						$region = new Region();
						$region->region = $othregion;
						$region->create();
						$service->regions_id = $region->id;
					} else
					{
						$service->regions_id = $reg_exist->id;
					}
					
				} else
				{
					$service->regions_id = $region;
				}
				$service->types_id = $type;
				$service->categories_id = $id;
				
				$image = $_FILES['image'];
				$service->attach_file($image);
				if($service->save())
				{
					$session->message('<p class="red">Tour added successfully.</p>');
					redirect_to('upload-service-images.php?service='.$service->id);
				} else
				{
					$message = join("<br />", $service->errors);
				}
			}
		}
	} else
	{
		$title = "";
		$intro = "";
		$details = "";
		$duration = 1;
		$price = 0;
		$deposit = 0;
		$region = "";
		$othregion = "";
	}
?>
<?php include_layout('html.php')?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" src="/ctgc/admin/ckeditor/ckeditor.js"></script>

<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
						<h1>ADD NEW SERVICE TO CATEGORY: <?php echo strtoupper($category->category); ?></h1>
						
						<p>
							<a href="manage-listings.php">CANCEL</a>
						</p>
						
						<?php if(isset($message) && $message != "") echo $message.'<br/>'; ?>
						
						<form method="post" action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" enctype="multipart/form-data">
							
							<div class="row">
								<div class="label">Summary Image</div>
								<input type="file" name="image" size="30" />
							</div>
							
							<?php include('../tour-guides-cape-town-layout/new-service-form.php'); ?>
							
							<div class="row">
								<div class="label">Position</div>
								<select name="position">
									<?php 
										$cat_services = Service::find_listings_by_category($id, 'AND current = 1');
										$count = count($cat_services);
										echo $count;
										for($i = 1; $i <= $count +1; $i++)
										{
											echo '<option value="'.$i;
											if($i == $count +1) echo '" selected="selected';
											echo '">'.$i.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" />
							</div>
						</form>
					
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>