<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	if(isset($_GET['cat']))
	{
		$cat_id = trim($_GET['cat']);
		$category = Category::find_by_id($cat_id);
	} else
	{
		$session->message('<p class="red">No category was provided.</p>');
		redirect_to('manage-tours.php');
	}
	?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{	
		$title = trim($_POST['title']);
		$intro = trim($_POST['intro']);
		$details = trim($_POST['details']);
		$duration = trim($_POST['duration']);
		$price = trim($_POST['price']);
		$deposit = trim($_POST['deposit']);
		$region = trim($_POST['region']);
		$othregion = trim($_POST['othregion']); // error if region = none and othregion = ""
		$position = trim($_POST['position']);
		$current = 1;
		
		//Check for errors
		$error = "";
		if($title == "")
		{
			$error .= "Title can not be blank. Please add a title.<br/>";
		}
		if(!ctype_digit($price))
		{
			$error .= "Only numbers are accepted for price. Please re-enter the price.<br/>";
		}
		if(!ctype_digit($deposit))
		{
			$error .= "Only numbers are accepted for deposit percentage. Please re-enter the amount.<br/>";
		}
		if($region == 'none' && $othregion == "")
		{
			$error .= "No region was selected. Please select a region or enter a new region name.<br/>";
		}
		
		if($error != "")
		{
			$message = '<p class="red">There are errors.<br/>';
			$message .= $error;
			$message .= '</p>';
		} else
		{		
			//Check for duplicate page name
			$pagename = strtolower(str_replace("-&", "", str_replace(" ", "-", str_replace("'", "", trim($title))))).'-tours.html';
			$page = Page::find_by_pagename($pagename);
			$serv = Service::find_by_pagename($pagename);
			if(!empty($page) || !empty($serv))
			{
				$message = "A page with the same name already exists. Please enter a different title.";
			} else
			{
				$service = new Service();	
				
				$image = $_FILES['image'];
				$service->attach_file($image);
				
				$service->pagename = $pagename;
				$service->title = $title;
				$service->intro = $intro;
				$service->details = $details;
				$service->duration = $duration;
				$service->price = $price;
				$service->deposit = $deposit;
				$service->current = $current;
				$service->position = $position;
				$service->categories_id = $cat_id;
				$service->types_id = 2;
				if($othregion != "")
				{
					$reg_exist = Region::find_by_region($othregion);
					if(!$reg_exist)
					{
						$region = new Region();
						$region->region = $othregion;
						$region->create();
						$service->regions_id = $region->id;
					} else
					{
						$service->regions_id = $reg_exist->id;
					}
				} else
				{
					$service->regions_id = $region;
				}
				
				if($service->save())
				{
					$session->message("Tour added successfully.");
					redirect_to('upload-service-images.php?service='.$service->id);
				} else
				{
					$message = join("<br />", $service->errors);
				}
			}
		}
	} else
	{
		$intro 		= "";
		$details 	= "";
		$title 		= "";
		$duration	= 1;
		$price 		= 0;
		$deposit	= 0;
		$region		= 0;
		$othregion	= "";
		$position 	= 0;
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" language="JavaScript">
			function toggleLayer( whichLayer )
			{
				var elem, vis;
				if( document.getElementById ) // this is the way the standards work
				elem = document.getElementById( whichLayer );
				else if( document.all ) // this is the way old msie versions work
				elem = document.all[whichLayer];
				else if( document.layers ) // this is the way nn4 works
				elem = document.layers[whichLayer];
				vis = elem.style;
				// if the style.display value is blank we try to figure it out here
				if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
				vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
				vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
		</script>
		
		<script type="text/javascript" src="/ctgc/admin/ckeditor/ckeditor.js"></script>		
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>ADD SET TOUR TO CATEGORY: <?php echo strtoupper($category->category); ?></h1>
						
						<p>
							<a href="manage-tours.php">CANCEL</a> 
						</p>
						
						<?php if(isset($session->message) && $session->message != "") echo $session->message.'<br/>'; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post" enctype="multipart/form-data" />
						
							<div class="row">
								<div class="label">Summary Image</div>
								<input type="file" name="image" size="30" />
							</div>
							
							<?php include_layout('new-service-form.php'); ?>
							
							<div class="row">
								<div class="label">Position</div>
								<select name="position">
									<?php 
										$cat_services = Service::find_set_tours_by_category($cat_id, ' AND current = 1');
										$count = count($cat_services);
										if($position == 0)
										{
											$position = $count+1;
										}
										for($i = 1; $i <= $count+1; $i++)
										{
											echo '<option value="'.$i;
											if($i == $position) echo '" selected="selected';
											echo '">'.$i.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" />
							</div>
						
						</form>
													
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>