<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	if(isset($_GET['tour']))
	{
		$tour_id = trim($_GET['tour']);
		$tour = Tour::find_by_id($tour_id);
		$service = Service::find_by_id($tour->services_id);
	} else
	{
		$session->message('<p class="red">No tour was provided.</p>');
		redirect_to('index.php');
	}
	?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{	
		$guide = trim($_POST['guide']);
		
		if($guide != 'none')
		{
			$tour->guides_id = $guide;
			if($tour->update())
			{
				$busy_days = BusyDay::find_by_tour($tour_id);
				foreach($busy_days as $busy_day)
				{
					$busy_day->guides_id = $guide;
					$busy_day->update();
				}
				$session->message("Tour guide added successfully.");
				if($service->types_id == 2)
				{
					redirect_to('tour-details.php?id='.$tour->id);
				} else
				{
					$enquiry = Enquiry::find_by_tour($tour->id);
					redirect_to('enquiry-details.php?id='.$enquiry->id);
				}
			} else
			{
				$message = '<p class="red">An error occurred. Please try again.</p>';
			}
		}
	} else
	{
		$guide	= $tour->guides_id;
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>SELECT GUIDE FOR TOUR: <?php echo strtoupper($service->title).' - '.$tour->start_date; ?></h1>
						
						<p>
							<a href="tour-details.php?id=<?php echo $tour_id; ?>">CANCEL</a> 
						</p>
						
						<?php if(isset($session->message) && $session->message != "") echo $session->message.'<br/>'; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post" />
						
							<div class="row">
								<div class="label">Suitable Guides:</div>
								<select name="guide">
									<option value="none">Please select...</option>
									<?php 
									if($service->types == 2)
										$guides = Guide::find_for_tour_only($tour_id);
									else
										$guides = Guide::find_for_tour($tour_id);
										foreach($guides as $guid)
										{
											echo '<option value="'.$guid->id;
											if($guid->id == $guide) echo '" selected="selected';
											echo '">'.$guid->firstname.' '.$guid->surname.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" />
							</div>
						
						</form>
													
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>