<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	if(isset($_GET['tour']))
	{
		$tour_id = trim($_GET['tour']);
		$tour = Tour::find_by_id($tour_id);
		$service = Service::find_by_id($tour->services_id);
		$guide = Guide::find_by_id($tour->guides_id);
	} else
	{
		$session->message('<p class="red">No tour was provided.</p>');
		redirect_to('manage-tours.php');
	}
	?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{	
		$vehicle = trim($_POST['vehicle']);
		
		if($vehicle != 'none')
		{
			$tourvehicle = new TourVehicle();
			$tourvehicle->vehicles_id = $vehicle;
			$tourvehicle->tours_id = $tour_id;
			if($tourvehicle->create())
			{
				$session->message("Vehicle added successfully.");
				redirect_to('tour-details.php?id='.$tour_id);
			} else
			{
				$message = '<p class="red">An error occurred. Please try again.</p>';
			}
		}
	} 
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
				
						<h1>ADD VEHICLE FOR TOUR: <?php echo strtoupper($service->title).' - '.$tour->start_date; ?></h1>
						
						<p>
							<a href="tour-details.php?id=<?php echo $tour_id; ?>">CANCEL</a> 
						</p>
						
						<?php if(isset($session->message) && $session->message != "") echo $session->message.'<br/>'; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post" />
						
							<div class="row">
								<div class="label">Suitable Vehicles:</div>
								<select name="guide">
									<option value="none">Please select...</option>
									<?php 
										if($guide)
										{
											$guide_vehs = Vehicle::find_by_guide($guide->id);
											if($guide_vehs)
											{
												foreach($guide_vehs as $guide_veh)
												{
													$car =  get_vehicle_details($guide_veh->id);
													echo '<option value="'.$guide_veh->id.'">';
													echo $car['make'].' '.$car['model'].' '.$car['year'].', seats '.$car['capacity'].', '.$car['colour'].'</option>';
												}
											}
										}
									?>
									<?php 
										$vehicles = find_vehicles_for_tour($tour_id);
										while($veh = mysql_fetch_array($vehicles))
										{
											echo '<option value="'.$vehicle['id'];
											echo '">'.$veh['make'].' '.$veh['model'].' '.$veh['year'].', seats '.$veh['capacity'].', '.$veh['colour'].'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<input type="submit" name="submit" value="Submit" />
							</div>
						
						</form>
													
					</div>
					
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>