<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	
	if(!isset($_GET['ref']))
	{
		$session->message('<p class="red">No reference was selected.</p>');
		redirect_to('select-email-reference.php');
	} else
	{
		$ref = trim($_GET['ref']);
		$enquiry = Enquiry::find_by_reference($ref);
		$client = Client::find_by_id($enquiry->clients_id);
		$tour = Tour::find_by_id($enquiry->tours_id);
		$guide = Guide::find_by_id($tour->guides_id);
		$coord = Coordinator::find_by_id($enquiry->coordinators_id);
		$user = User::find_by_id($session->user_id);
		$message = $session->message;
		
		if($_SERVER['REQUEST_METHOD'] == "POST")
		{
			// check details
			$to = trim($_POST['to']);
			$cc = trim($_POST['cc']);
			$cc2 = trim($_POST['cc2']);
			$from = trim($_POST['from']);
			$subject = trim($_POST['subject']);
			$emessage = trim($_POST['message']);
			
			// send email
			$subject	= $enquiry->reference." - Website Boooking Enquiry";
			$headers	= "From: ".$from."\r\n";
			$headers	.= "Reply-To: ".$from."\r\n";
			$headers 	.= "CC: ".$coord->email."\r\n";
			if($cc != "") $headers .=  "CC: ".$cc."\r\n";
			if($cc2 != "") $headers .=  "CC: ".$cc2."\r\n";
			$headers	.= "MIM-Version: 1.0\r\n";
			$headers	.= "Content-Type: text/html; charset=ISO-8859-1\r\n";
			
			$email_body	= '<html><body style="font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;">';
			$email_body .= '<h1>'.$enquiry->reference.'</h1>';
			$email_body	.= $emessage;
			$email_body	.= '</body></html>';
			
			if(mail($to, $subject, $email_body, $headers))
			{
				// add enquiry note
				$note = new Note();
				$note->details = 'Email sent to client:<br/><b>Subject: '.$subject.'</b><br/>'.$emessage;
				$note->users_id = $session->user_id;
				if($note->create())
				{
					$enqnote = new EnquiryNote();
					$enqnote->notes_id = $note->id;
					$enqnote->enquiries_id = $enquiry->id;
					$enqnote->create();
				}
				$session->message('<p class="green">Email sent successfully.</p>');
				redirect_to('enquiry-details.php?id='.$enquiry->id);
			} else
			{
				$message('<p class="red">The email could not be sent at this time. Please check the details and try again.</p>');
			}
		} else
		{
			$to = $client->email;
			if($coord) $cc = $coord->email;
			else $cc = "";
			$cc2 = "";
			$usercoord = Coordinator::find_by_id($user->coordinators_id);
			$from = $usercoord->email;
			$subject = 'CAPE TOURIST GUIDE BOOKING, REF #'.$ref;
			$emessage = "";
		}
	}
	?>
<?php include_layout('html.php')?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" src="/ctgc/admin/ckeditor/ckeditor.js"></script>

<?php include_layout('header-admin.php'); ?>

			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
					
						<h1>SEND AN EMAIL</h1>
						
						<p><a href="enquiry-details.php?id=<?php echo $enquiry->id; ?>">CANCEL</a></p>
						
						<?php if($message != "") echo $message.'<br/>'; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post">
							<div class="row">
								<label class="field">TO: </label>
								<select name="to">
									<option value="<?php echo $client->email.'"'; 
										if($to == $client->email) echo ' selected="selected"';
									?>" >
										<?php echo $client->firstname.' '.$client->surname.': '.$client->email; ?>
									</option>
									<?php if($guide)
									{
										echo '<option value="'.$guide->email;
										if($to == $guide->email) echo '" selected="selected';
										echo '">';
										echo $guide->firstname.' '.$guide->surname.': '.$guide->email;
										echo '</option>';
									}?>
									<option value="none">Other...</option>
								</select>
							</div>
							
							<div class="row">
								<label class="field">CC: </label>
								<input type="text" name="cc" size="60" value="<?php echo $cc; ?>" />
							</div>
							
							<div class="row">
								<label class="field">CC 2: </label>
								<input type="text" name="cc2" size="60" value="<?php echo $cc2; ?>" />
							</div>
							
							<div class="row">
								<label class="field">FROM: </label>
								<input type="text" name="cc" size="60" value="<?php echo $from; ?>" />
							</div>
							
							<div class="row">
								<label class="field">SUBJECT: </label>
								<input type="text" name="subject" size="60" value="<?php echo $subject; ?>" />
							</div>
							
							<div class="row">
								<textarea class="ckeditor" name="message"><?php echo $emessage; ?></textarea>
							</div>
							
							<div class="row">
								<input type="submit" name="submit" value="Send" />
							</div>
						</form>
						
					</div>
				</div>
			</div>
			
<?php include_layout('footer-admin.php'); ?>