<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	?>
<?php 
	if(isset($_GET['id']))
	{
		$id = trim($_GET['id']);
		$tour = get_tour_details($id);
		$enquiries = Enquiry::find_by_tour($id);
	} else
	{
		$session->message("No tour number was provided.");
		redirect_to('manage-tours.php');
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript" language="JavaScript">
			function toggleLayer( whichLayer )
			{
				var elem, vis;
				if( document.getElementById ) // this is the way the standards work
				elem = document.getElementById( whichLayer );
				else if( document.all ) // this is the way old msie versions work
				elem = document.all[whichLayer];
				else if( document.layers ) // this is the way nn4 works
				elem = document.layers[whichLayer];
				vis = elem.style;
				// if the style.display value is blank we try to figure it out here
				if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
				vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
				vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
		</script>
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
						<h1>TOUR DETAILS</h1>
						
						<?php if(isset($session->message) && $session->message != "") echo '<br/>'.$session->message.'<br/>'; ?>
						
						<p>
							<a href="edit-tour-date.php?id=<?php echo $id; ?>">EDIT</a>&nbsp;&nbsp;|&nbsp;
						<?php //	<a href="cancel-tour.php?id= echo $id; ">CANCEL TOUR</a>&nbsp;&nbsp;|&nbsp;?>
							<a href="manage-tours.php">ALL TOURS</a>
						</p>
						
						<table class="borderless">
							<tr><td>Status: </td><td><?php echo $tour['tour_status']; ?></td></tr>
							<tr><td>Service: </td><td><?php echo $tour['title']; ?></td></tr>
							<?php $phpstart = strtotime($tour['start_date']); ?>
							<tr><td>Tour Date/s:</td><td> <?php echo date('d M Y', $phpstart);  
							if($enquiry['duration'] >1) echo ' - '.date('d M Y', ($phpstart +(($tour['duration'] -1) * 86400))); ?></td></tr>
							<tr><td>Language: </td><td><?php echo $tour['language']; ?></td></tr>
							<tr><td>Guide: </td><td><a href="select-tour-guide.php?tour=<?php echo $id;?>" title="Change guide"><?php echo $tour['firstname'].' '.$tour['surname']; ?></a></td></tr>
						</table>
						
						<p>
							<a href="tour-expenses.php?id=<?php echo $id; ?>"><button onClick="javascript:location.href='tour-expenses.php?id=<?php echo $id; ?>';">Expenses</button></a>
						</p>
						
						<h2>ENQUIRIES FOR THIS TOUR</h2>
						<?php 
							if(empty($enquiries))
							{
								echo 'No enquiries for this tour.';
							}
							foreach($enquiries as $enquiry)
							{
								$enq = get_enquiry_details($enquiry->reference);
								
								echo '<h2>Ref# '.$enquiry->reference.'</h2>';
						?>
								<p>
									<a href="enquiry-details.php?id=<?php echo $enquiry->id; ?>">FULL DETAILS</a>&nbsp;&nbsp;|&nbsp;
									<a href="edit-enquiry.php?id=<?php echo $enquiry->id; ?>">EDIT</a>&nbsp;&nbsp;|&nbsp;
									<a href="send-email.php?ref=<?php echo $enquiry->reference; ?>">SEND EMAIL</a>
								</p>
								
								<table class="borderless">
									<tr><td>Name</td><td><?php echo $enq['cfirstname'].' '.$enq['csurname']; ?></td></tr>
									<tr><td>Status</td><td><?php $status = Status::find_by_id( $enq['status']);
									echo $status->status; ?></td></tr>
									<tr><td>No. people</td><td><?php echo $enq['people']; ?></td></tr>
									<tr><td>Preferred Language</td><td><?php echo $enq['clanguage']; ?></td></tr>
									<tr><td>Preferred Contact</td><td><?php echo $enq['communication_method'].': '; 
										if($enq['communication_method'] == 'Email') echo '<a href="send-email.php?ref='.$enq['reference'].'&to=client">'.$enq['cemail'].'</a>';
										else echo $enq['ctel'];
									?></td></tr>
									<tr><td>Local Address</td><td><?php echo $enq['esname'].', '.$enq['essuburb']; ?></td></tr>
									<tr><td>Payment Due</td><td>R <?php echo $enq['due_now']; ?></td></tr>
								</table>
						<?php 
							}
						?>
						
						<?php 
							$notes = Note::find_by_tour($id);
							if($notes)
							{
								echo '<h2>NOTES</h2>';
								foreach($notes as $note)
								{
									$user = User::find_by_id($note->users_id);
									$usercoord = Coordinator::find_by_id($user->coordinators_id);
									echo '<p>'.$note->details.'<br/>';
									echo '<label class="small"> - Added by '.$usercoord->name.' at '.$note->timestamp.'</label></p>';
								}
							}
						?>
						
					</div>
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>