<?php require_once("../guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!$session->is_logged_in()) {redirect_to("login.php");} 
	if($session->is_admin_user() == false) {redirect_to("guide-list.php");} 
	?>
<?php 
	if(!isset($_GET['id']))
	{
		$session->message('<p class="red">No tour reference was provided.</p>');
		redirect_to('manage-enquiries.php');
	} else
	{
		$message = $session->message;
		$id = trim($_GET['id']);
		$tour = Tour::find_by_id($id);
		$service = Service::find_by_id($tour->services_id);
		if($service->types_id != 2) $enquiry = array_shift(Enquiry::find_by_tour($id));
		$referr = $_SERVER['HTTP_REFERER'];
		
		if($_SERVER['REQUEST_METHOD'] == "POST")
		{
			// process and add details.
			$amount = trim($_POST['amount']);
			$date = trim($_POST['date']);
			$extype =trim($_POST['extype']); 
			$details = trim($_POST['details']);
			$error = "";
			if($amount == "" || $amount == 0) $error .= 'Amount must be entered.<br/>';
			else if(!ctype_digit($amount)) $error .= 'Amount must be a number.<br/>';
			if($date == "" || $date == 'dd/mm/yyyy') $error .= 'Payment Date.<br/>';
			if($details == '') $error .= 'Expense Details.<br/>';
			
			if($error != "")
			{
				$message = '<p class="red">SOME REQUIRED FIELDS ARE BLANK> PLEASE COMPLETE THE FOLLOWING INFORMATION:<br/>'.$error.'</p>';
			} else
			{
				$exp = new Expense();
				$exp->date_paid = date('Y-m-d', strtotime($date));
				$exp->tours_id = $id;
				$exp->expense_types_id = $extype;
				$exp->amount = $amount;
				$exp->details = $details;
				$exp->create();
			}
		} else
		
		if(!isset($date)) $date = 'dd/mm/yyyy';
		if(!isset($amount)) $amount = "";
		if(!isset($extype)) $extype = "";
		if(!isset($details)) $details = "";
			
		$expenses = Expense::find_by_tour($id);
		$count = count($expenses);
		$total = Expense::find_tour_cost($id);
	}
?>
<?php include_layout('html.php'); ?>
		<title>Cape Tourist Guide Connection - ctgc.com</title>
		
		<meta name="keywords" content="" />
		<meta name="description" content=""/>
		
		<script type="text/javascript">
			<!--
			function popup(mylink, windowname, dimensions)
			{
			if (! window.focus)return true;
			var href;
			if (typeof(mylink) == 'string')
			   href=mylink;
			else
			   href=mylink.href;
			window.open(href, windowname, dimensions);
			return false;
			}
			//-->
		</script>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		<link rel="stylesheet" href="/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />
		
<?php include_layout('header-admin.php'); ?>
			
			<div id="main_page">
			
				<?php include_layout('admin-menu.php'); ?>
			
				<div id="admin_page">
				
					<div class="admin_content">
					
						<h1>TOUR EXPENSES<?php if(isset($enquiry)) echo ' FOR ENQUIRY REF #'.$enquiry->reference; ?></h1>
						
						<p><a href="<?php echo $referr; ?>">&laquo; BACK</a></p>
						
						<?php if(isset($message) && $message != "") echo $message; ?>
						
						<table class="borderless">
							<tr><td width="180px">Total Expenses:</td><td>R <?php if($total) echo $total; 
							else echo 0;?></td></tr>
						</table>
						
						<h2>EXPENSE DETAILS</h2>
						
						<?php 
							if(empty($expenses)) echo '<p>No expenses have been submitted.</p>';
							else
							{
								foreach($expenses as $expense)
								{
									$type = ExpenseType::find_by_id($expense->expense_types_id);
									echo '<table class="borderless">';
									echo '<tr><td width="180px">Amount</td><td>R '.$expense->amount.'</td></tr>';
									echo '<tr><td>Payment Date</td><td>'.date('d M Y', strtotime($expense->date_paid)).'</td></tr>';
									echo '<tr><td>Other details</td><td>'.$expense->details.'</td></tr>';
									echo '</table>';
								} 
							}
						?>
						
						<h2>ADD NEW EXPENSE</h2>
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post">
						
							<div class="row">
								<div class="label">Amount (ZAR)</div>
								<input type="text" name="amount" value="<?php echo $amount; ?>" size="10" />
							</div>
							
							<div class="row">
								<div class="label">Payment Date</div>
								<script>
									$(function() {
										$( "#datepicker" ).datepicker({
											dateFormat: 'dd/mm/yy'
											});
									});
								</script>
								<input type="text" name="date" value="<?php echo $date; ?>" id="datepicker"  size="20" />
							</div>
							
							<div class="row">
								<div class="label">Expense Type</div>
								<select name="extype">
									<?php 
										$types = ExpenseType::find_all();
										foreach($types as $type)
										{
											echo '<option value="'.$type->id;
											if($type->id == $extype) echo '" selected="selected';
											echo '">'.$type->type.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">Details</div>
								<textarea name="details" cols="40" rows="5"><?php echo $details; ?></textarea>
							</div>
							
							<div class="row">
								<div class="label">&nbsp;</div>
								<input type="submit" name="submit" value="submit" />
							</div>
						
						</form>
						
					</div>
				</div>
				
			</div>
			
<?php include_layout('footer-admin.php'); ?>