<?php require_once("guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(isset($_GET['service']))
	{
		$service_id = mysql_prep($_GET['service']);
		$service = Service::find_by_id($service_id);
	} else
	{
		$session->message("A tour needs to be selected in order to proceed to the booking page. Please select a tour or send us an enquiry.");
		redirect_to('select-service.php');
	}
?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$firstname 		= trim(strip_tags($_POST['firstname']));
		$surname 		= trim(strip_tags($_POST['surname']));
		$country		= trim(strip_tags($_POST['country']));
		$other_country	= trim(strip_tags($_POST['other_country']));
		if($country == 'none')
		{
			if($other_country != '')
			{
				$coun = new Country();
				$coun->country = $other_country;
				$coun->create();
				$country = $coun->id;
			}
		}
		$email 			= trim(strip_tags($_POST['email']));
		$tel 			= trim(strip_tags($_POST['tel']));
		$contact 		= trim(strip_tags($_POST['contact']));
		if($_POST['date'] == "" || $_POST['date'] == 'dd/mm/yyyy')
		{
			$date = "";
		} else
		{
			$date			= date('Y-m-d', strtotime((str_replace('/','-', strip_tags($_POST['date'])))));
		}
		$people			= trim(strip_tags($_POST['people']));
		$language		= trim(strip_tags($_POST['language']));
		$requirements	= trim(strip_tags($_POST['requirements']));
		$establishment	= trim(strip_tags($_POST['establishment']));
		$estname		= trim(strip_tags($_POST['estname']));
		$address		= trim(strip_tags($_POST['address']));
		$esttel			= trim(strip_tags($_POST['esttel']));
		$estregion		= trim(strip_tags($_POST['estregion']));
		$comments		= trim(strip_tags($_POST['comments']));
			
		if(!isset($_POST['terms']))
		{
			$message = '<p class="red">Terms & Conditions must be accepted in order to proceed.</p>';
		} else
		{
			if($establishment == 'other' && $esttel != "" && $address != "" && $estregion != 'none')
			{
				$est = new Establishment();
				if($estname == "")
				{
					$estname = "private accommodation";
				}
				$est->name = $estname;
				$est->address = $address;
				$est->tel = $esttel;
				$est->list = 0;
				$est->suburbs_id = $estregion;
				$est->create();
				$establishment = $est->id;
			}
			
			$message = "";
			//	Check required fields 
			
			$labels = array( 
			'firstname'=>"First Name",
			'surname'=>"Surname",
			'email'=>'Email address',
			'tel'=>'Phone Number',
			'contact'=>'Contact Method',
			'country'=>'Country',
			'other_country'=>'Country',
			'service'=>'Service Selection',
			'date'=>'Departure date',
			'people'=>'Number of people',
			'language'=>'Preferred Language',
			'requirements'=>'Special Requirements',
			'establishment'=>'Select local address from list or complete all details for other local address',
			'estname'=>'Establishment Name',
			'address'=>'Establishment Address',
			'estregion'=>'Establishment Suburb',
			'esttel'=>'Establishment Phone Number',
			'comments'=>'comments'
			);
			
			foreach($_POST as $field=>$value)
			{
				if($field == 'firstname' || $field == 'surname' || $field == 'email' || $field == 'tel')
				{
					if(empty($_POST[$field]) || ($field == 'language' && $value == 'none') || ($field == 'date' && ($value == 'dd/mm/yyyy' || $value == "")))
					{
						$blanks[$field] = "blank";
					}
				}  else if($field == 'country' && $value == 'none')
				{
					if($_POST['other_country'] == "")
					{
						$blanks[$field] = "blank";
					}
				}else if(($field == 'service' || $field == 'people' || $field == 'language') && $value == 'none')
				{
					$blanks[$field] = "blank";
				} else if($field == 'establishment' && ($value == 'none' || $value == 'other'))
				{
					if($estname == "" || $address == "" || $esttel == "" || $estregion == "none")
					{
						$blanks[$field] = "blank";
					}
				}
			}
			
			if(!empty($blanks))
			{
				if(sizeof($blanks)>0)
				{
					$message .= "<p class=\"red\">ONE OR MORE OF THE REQUIRED FIELDS ARE BLANK.<br/>Please enter the following information:<br>";
					foreach ($blanks as $field => $value)
					{
						$message .= "&nbsp;&nbsp;&nbsp;{$labels[$field]}<br/>";
					}
					$message .= "</p>";
				}
			} else
			{	
				if($service->types_id != 2)
				{
					// Create tour, client, new enquiry & ref
					$tour = new Tour();
					$tour->start_date 	= $date;
					$tour->capacity = $people;
					$tour->services_id 	= $service_id;
					$tour->guides_id = "";
					$tour->languages_id = $language;
					$tour->create();
				} else
				{
					$tour = array_shift(Tour::find_by_service($service_id, ' AND start_date='.$date));
				}
				
				$client = new Client();
				$client->firstname 					= $firstname;
				$client->surname 					= $surname;
				$client->countries_id				= $country;
				$client->languages_id				= $language;
				$client->tel 						= $tel;
				$client->email 						= $email;
				$client->communication_methods_id 	= $contact;
				$client->establishments_id			= $establishment;
				if($client->create())
				{
					$enquiry = new Enquiry();
					$maxid = get_max_id('enquiries');
					$enquiry->reference				= ($maxid +1001).'W';
					$enquiry->created				= date('Y-m-d h:i:s', time());
					$enquiry->no_people				= $people;
					$enquiry->status 				= 1;
					$cost 							= $service->price * $people;
					$deposit						= $cost*$service->deposit/100;
					$enquiry->total_cost 			= $cost;
					$enquiry->deposit				= $deposit; 
					$enquiry->due_now				= $deposit;
					$enquiry->clients_id 			= $client->id;
					$enquiry->tours_id 				= $tour->id;
					$enquiry->enquiry_methods_id 	= 1;
					$enquiry->coordinators_id		= 1;
					$enquiry->create();
					
					if($service->types_id != 2)
					{
						// Need to create enquiry busy days entry/s
						for($k = 0; $k < $service->duration; $k++)
						{
							$busy_day = new BusyDay();
							$busy_day->guides_id = "";
							$busy_day->tours_id = $tour->id;
							$busy_day->status_id = 1;
							$busy_day->date = date('Y-m-d', (strtotime($date) + ($k * 86400)));
							$busy_day->create();
						}
					}
					
					// Add Enquiries status 
					{
						$enquiries_status = new EnquiryStatus();
						$enquiries_status->enquiries_id = $enquiry->id;
						$enquiries_status->status_id = 1;
						$enquiries_status->create();
					}
				}
				
				// Get all text info for email
				$cm = CommunicationMethod::find_by_id($contact);
				$l = Language::find_by_id($language);
				$c = Country::find_by_id($country);
				$es = Establishment::find_by_id($establishment);
				$esreg = Suburb::find_by_id($es->suburbs_id);
				
				$emessage = '<b>CLIENT DETAILS</b><br/>';
				$emessage .= '<table style=" font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;" cellpadding="5">';
				$emessage .= '<tr><td>NAME: </td><td>'.$firstname.' '.$surname.'</td></tr>';
				$emessage .= '<tr><td>EMAIL ADDRESS: </td><td>'.$email.'</td></tr>';
				$emessage .= '<tr><td>PHONE NUMBER: </td><td>'.$tel.'</td></tr>';
				$emessage .= '<tr><td>PREFERRED CONTACT METHOD: </td><td>'.$cm->name.'</td></tr>';
				$emessage .= '<tr><td>LANGUAGE: </td><td>'.$l->language.'</td></tr>';
				$emessage .= '<tr><td>COUNTRY OF ORIGIN: </td><td>'.$c->country.'</td></tr>';
				$emessage .= '<tr><td>LOCAL ADDRESS:  </td><td>'.$es->name.' - '.$es->address.', '.$esreg->suburb.', TEL: '.$es->tel.'</td></tr>';
				$emessage .= '<tr><td>SPECIAL REQUIREMENTS:  </td><td>';
				if($requirements != "none")
				{
					$r = SpecialRequirement::find_by_id($requirements);
					$emessage .= $r->name;
				} else
				{
					$emessage .= 'NO';
				}
				$emessage .= '</td></tr></table><br/>';
				
				$emessage .= '<b>TOUR DETAILS</b><br/>';
				$emessage .= '<table style=" font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;" cellpadding="5">';
				$emessage .= '<tr><td>TYPE OF TOUR: </td><td>'.$service->title.'</td></tr>';
				$emessage .= '<tr><td>STARTING ON: </td><td>'.$date.'</td></tr>';
				$emessage .= '<tr><td>DURATION (DAYS): </td><td>'.$service->duration.'</td></tr>';
				$emessage .= '<tr><td>NUMBER OF PEOPLE: </td><td>'.$people.'</td></tr></table>';
				if($comments != '')
				{
					$emessage .= 'COMMENTS: <br/><br/>'.$comments.'<br/>';
					$note = new Note();
					$note->details = $comments;
					$note->users_id = 0;
					$note->create();
					
					$enq_note = new EnquiryNote();
					$enq_note->notes_id = $note->id;
					$enq_note->enquiries_id = $enquiry->id;
					$enq_note->create();
				}
				
				if($people > 7)
				{
					$emessage .= '<p style="color:#F05500;">This booking is for 8 or more people.</p>';
					$give_ref = "";
				} 
				if($requirements != 'none')
				{
					$emessage .= '<p style="color:#F05500;">This booking has special requirements.</p>';
					$give_ref = "";
				}
				
				if($service->types_id != 2 && !isset($give_ref))
				{
					// Check for guide with vehicle
					$guidefound = Guide::find_for_tour($tour->id);
					
					if(!empty($guidefound))
					{
						$tour->guides_id = $guidefound->id;
						$tour->update();
						
						$enquiry->status = 2;
						$enquiry->update();
						
						$enqstatus = new EnquiryStatus();
						$enqstatus->enquiries_id = $enquiry->id;
						$enqstatus->status_id = 2;
						$enqstatus->create();
						
						$bds = BusyDay::find_by_tour($tour->id);
						foreach($bds as $bd)
						{
							$bd->guides_id 	= $guidefound->id;
							$bd->status		= 2;
							$bd->update();
						}
					} else
					{
						$emessage .= '<p style="color:#F05500;">No guide was found on the system.</p>';
						$give_ref = "yes";
					}
				}
				
				// send email								
				$to 		= "info@freshweb.co.za";
				$subject	= $enquiry->reference." - Website Boooking Enquiry";
				$headers	= "From: ".$email."\r\n";
				$headers	.= "Reply-To: ".$email."\r\n";
			//	$headers	.= "CC: fleur@freshweb.co.za\r\n";
				$headers	.= "MIME-Version: 1.0\r\n";
				$headers	.= "Content-Type: text/html; charset=ISO-8859-1\r\n";
				
				$email_body	= '<html><body style="font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;">';
				$email_body .= '<h1>'.$enquiry->reference.'</h1>';
				$email_body	.= $emessage;
		//		$email_body	.= '<img src="http://www.freshweb.co.za/cape-tours-name.jpg" alt="Cape Tourist Guide Connection" />';
				$email_body	.= '</body></html>';
				
				$mailsend = mail($to, $subject, $email_body, $headers);
				
				$session->message('<p class="green">Thank you for your enquiry. One of our co-ordinators will contact you.</p>');
				redirect_to('booking-details.php?ref='.$enquiry->reference);
			}
		}
	} else
	{
		
		$firstname 		= "";
		$surname 		= "";
		$country		= "";
		$other_country 	= "";
		$email 			= "";
		$tel 			= "";
		$contact 		= "1";
		$date			= 'dd/mm/yyyy';
		$people			= "";
		$language		= "";
		$requirements	= "";
		$establishment	= "";
		$estname		= "private accommodation";
		$address		= "";
		$esttel			= "";
		$estregion		= "";
		$comments		= "";
		global $firstname;
	}
?>
<?php include_layout('html.php'); ?>

		<script type="text/javascript" language="JavaScript">
			function toggleLayer( whichLayer )
			{
			var elem, vis;
			if( document.getElementById ) // this is the way the standards work
			elem = document.getElementById( whichLayer );
			else if( document.all ) // this is the way old msie versions work
			elem = document.all[whichLayer];
			else if( document.layers ) // this is the way nn4 works
			elem = document.layers[whichLayer];
			vis = elem.style;
			// if the style.display value is blank we try to figure it out here
			if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
			vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
			vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
		</script>
		
		<script type="text/javascript" src="/ctgc/dates/js/jquery-1.4.2.min.js" ></script>
		<script type="text/javascript" src="/ctgc/dates/js/jquery-ui-1.8.6.custom.min.js" ></script>
		<link rel="stylesheet" href="/ctgc/dates/css/jquery-ui-1.8.6.custom.css" type="text/css" media="all" />
		
<?php include('./tour-guides-cape-town-layout/header.php'); ?>

			<div id="double"> 
				
				<div class="left">
				
					<div id="left_content">
						
						<h1>BOOKING ENQUIRY - <?php echo strtoupper($service->title); ?></h1>
						
						<?php if(isset($message) && $message != "") echo $message; ?>
						
						<form action="<?php echo $_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']; ?>" method="post">
						
							<?php include('./tour-guides-cape-town-layout/enquiry-form.php'); ?>
						
						<p><br/><br/>Please be patient while our system checks for availability according to the information provided.</p>
					
					</div>
				</div>
				
				<?php include_layout('right-menu.php'); ?>
				
				<img src="/ctgc/tourism-south-africa/cape-tours-2-bott.gif" width="1005px" height="1px" />
			</div>
			
<?php include_layout('footer.php'); ?>
