<?php require_once("guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!isset($_GET['ref']))
	{
		$session->message('<p class="red">Please provide a booking reference number.</p>');
		redirect_to('booking-reference.php');
	} else 
	{
		$ref = strtoupper(trim(strip_tags($_GET['ref'])));
		if($_SERVER['REQUEST_METHOD'] != "POST")
		{
			$session->message('<p class="red">Please provide a payment amount.</p>');
			redirect_to('booking-payment.php?ref='.$ref);
		} else
		{
			$amount = trim(strip_tags($_POST['amount']));
			$pmtref = trim(strip_tags($_POST['pmtref']));
			$message = $session->message;
			$title_tag = 'Confirm Payment Amount';
			
			$online = new OnlinePayment();
			$online->amount = $amount;
			$online->date = date('Y-m-d h:i:s');
			$online->enquiries_ref = $ref;
			$online->reference = $pmtref;
			$online->create();
			
			$opid = $online->id;
			
			$payment = new Payment();
			$payment->date = date('Y-m-d');
			$payment->enquiries_ref = $ref;
			$payment->reference = $pmtref;
			$payment->amount = 0;
			$payment->payment_methods_id = 1;
			$payment->comments = 'To be confirmed';
			$payment->create();
			
			$pid = $payment->id;
		}
	}
?>
<?php include_layout('html.php'); ?>
		
		<script type="text/javascript">
		<!--
			function IsNumeric(sText)
			{
				var ValidChars = "0123456789.";
				var IsNumber=true;
				var Char;
				for (i = 0; i < sText.length && IsNumber == true; i++) 
				{ 
					Char = sText.charAt(i); 
					if (ValidChars.indexOf(Char) == -1) 
					{
						alert('Please enter only numbers or decimal points in the amount field');
						IsNumber = false;
					}
				}
			   return IsNumber;
			}
				
			function validate_form(thisform)
			{
				with(thisform)
				{
				  	if (IsNumeric(txtPrice.value)==false) 
				   	{ 
				      txtPrice.focus(); 
				      return false; 
				   	} else
					return true;
				}
			}
		//-->
		</script>
		
	<?php include('./tour-guides-cape-town-layout/header.php'); ?>

			<div id="double"> 
				
				<div class="left">
				
					<div id="left_content">
						
						<?php if(isset($message) && $message != "") echo $message; ?>
						<h1>CONFIRM PAYMENT - REF # <?php echo $ref; ?></h1>
						
						<p>You will now be redirected to a secure payment page.</p>
						<p>Payment Amount: R <?php echo $amount; ?></p>
												
						<form action="https://www.mygate.co.za/virtual/8x0x0/dsp_ecommercepaymentparent.cfm" method="post" onsubmit="return validate_form(this)">
						
							 	<input type="hidden" name="txtMerchantID" value="0D3E9522-A48F-43FE-BF64-07F7A0474092" />
								<input type="hidden" name="txtApplicationID" value="B3B4E392-8E34-4A7E-A4D1-E500EFED0364" />
					<?php 	//	<input type="hidden" name="Mode" value="0" />
						//	<input type="hidden" name="txtMerchantID" value="79958a8d-0c7b-4038-8e2e-8948e1d678e1" />
						//	<input type="hidden" name="txtApplicationID" value="d48750f9-1dc0-4290-a94c-9a1c9f7e2fb1" />
						//	<input type="hidden" name="txtMerchantReference" value="<?php echo $pmtref; " />
							?>
							<input name="txtPrice" type="hidden" value="<?php echo $amount; ?>" />
							<input type="hidden" name="Mode" value="0">
							<input type="hidden" name="txtMerchantReference" value="INV15642">
							<input type="hidden" name="txtCurrencyCode" value="ZAR">
							<input type="hidden" name="txtRedirectSuccessfulURL" value="http://www.capetouristguide.co.za/payment-results.html?ref=<?php echo $ref; ?>">
							<input type="hidden" name="txtRedirectFailedURL" value="http://www.capetouristguide.co.za/payment-results.html?ref=<?php echo $ref; ?>">
							<input type="hidden" name="Variable1" value="<?php echo $opid; ?>" />
							<input type="hidden" name="Variable2" value="<?php echo $pid; ?>" />
							
							<div class="row">
								<input type="submit" name="submit" value="Proceed" />
							</div>
						</form>
				
					</div>
				</div>
				
				<?php include_layout('right-menu.php'); ?>
				
				<img src="/ctgc/tourism-south-africa/cape-tours-2-bott.gif" width="1005px" height="1px" />
			</div>

			<?php include_layout('footer.php'); ?>