<?php require_once("guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(!isset($_GET['ref']))
	{
		$session->message('<p class="red">Please provide a reference number.</p>');
		redirect_to('booking-reference.php');
	} else
	{
		$ref = trim(strip_tags($_GET['ref']));
		$enquiry = Enquiry::find_by_reference($ref);
		$coord = Coordinator::find_by_id($enquiry->coordinators_id);
		$client = Client::find_by_id($enquiry->clients_id);
		if(empty($enquiry))
		{
			$session->message('<p class="red">Please provide a valid reference number.</p>');
			redirect_to('booking-reference.php');
		}
		$title_tag = 'Email us for information or to adjust your booking.';
	}
?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$comments		= trim(strip_tags($_POST['comments']));
			
		// Add enquiry note	
		if($comments != '')
		{
			$note = new Note();
			$note->details = $comments;
			$note->users_id = 0;
			$note->create();
			
			$enq_note = new EnquiryNote();
			$enq_note->notes_id = $note->id;
			$enq_note->enquiries_id = $enquiry->id;
			$enq_note->create();
		
			// send email								
			$to 		= $coord->email; 
			$subject	= $enquiry->reference." - Enquiry Changes";
			$headers	= "From: ".$client->email."\r\n";
			$headers	.= "Reply-To: ".$client->email."\r\n";
			$headers	.= "MIME-Version: 1.0\r\n";
			$headers	.= "Content-Type: text/html; charset=ISO-8859-1\r\n";
			
			$email_body	= '<html><body style="font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;">';
			$email_body .= '<h1>'.$enquiry->reference.'</h1>';
			$email_body	.= '<p>'.$comments.'</p>';
			$email_body	.= '</body></html>';
			
			$mailsend = mail($to, $subject, $email_body, $headers);
			
			redirect_to('booking-details.php');
		} else
		{
			$message = '<p class="red">Please enter a message.</p>';
		}
	} else
	{
		$comments		= "";
	}
?>
<?php include_layout('html.php'); ?>
		
		<script type="text/javascript" language="JavaScript">
		<!--
			function toggleLayer( whichLayer )
			{
			var elem, vis;
			if( document.getElementById ) // this is the way the standards work
			elem = document.getElementById( whichLayer );
			else if( document.all ) // this is the way old msie versions work
			elem = document.all[whichLayer];
			else if( document.layers ) // this is the way nn4 works
			elem = document.layers[whichLayer];
			vis = elem.style;
			// if the style.display value is blank we try to figure it out here
			if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
			vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
			vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
			//-->
		</script>
		
<?php include('./tour-guides-cape-town-layout/header.php'); ?>

			<div id="double"> 
				
				<div class="left">
				
					<div id="left_content">
						
						<h1>EMAIL US REGARDING ENQUIRY REF# <?php echo strtoupper($ref); ?></h1>
						
						<p><a href="/ctgc/booking-details.php?ref=<?php echo $ref; ?>" title="Back to booking details">&laquo; BACK</a></p>
						
						<?php if(isset($message) && $message != "") echo $message; ?>
						
						<form action="/enquiry-email.php?ref=<?php echo $ref; ?>" method="post">
							<h3>MESSAGE DETAILS</h3>
							
							<div class="row">
								<textarea name="comments" style="width:710px;" rows="20" ><?php echo $comments; ?></textarea>
							</div>				
							
							<div class="row">
							<br/>
								<input type="submit" name="submit" value="Send Email" />&nbsp;&nbsp;<input type="reset" name="reset" value="Reset" />
								<br/><br/>
							</div>
						</form>
					
					</div>
				</div>
				
				<?php include_layout('right-menu.php'); ?>
				
				<img src="/ctgc/tourism-south-africa/cape-tours-2-bott.gif" width="1005px" height="1px" />
			</div>
			
<?php include_layout('footer.php'); ?>
