<?php require_once("guided-tours-cape-town-includes/cape-guided-tours-requirements.php"); ?>
<?php 
	if(isset($_GET['service']))
	{
		redirect_to('booking-enquiry.php?service='.$_GET['service']);
	} 
?>
<?php 
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$firstname 		= trim(strip_tags($_POST['firstname']));
		$surname 		= trim(strip_tags($_POST['surname']));
		$country		= trim(strip_tags($_POST['country']));
		$other_country	= trim(strip_tags($_POST['other_country']));
		if($country == 'none')
		{
			if($other_country != '')
			{
				$coun = new Country();
				$coun->country = $other_country;
				$coun->create();
				$country = $coun->id;
			}
		}
		$email 			= trim(strip_tags($_POST['email']));
		$tel 			= trim(strip_tags($_POST['tel']));
		$contact 		= trim(strip_tags($_POST['contact']));
		$language		= trim(strip_tags($_POST['language']));
		$comments		= trim(strip_tags($_POST['comments']));
			
		if(!isset($_POST['terms']))
		{
			$message = '<p class="red">Terms & Conditions must be accepted in order to proceed.</p>';
		} else
		{
			$message = "";
			
			//	Check required fields 
			$labels = array( 
			'firstname'=>"First Name",
			'surname'=>"Surname",
			'email'=>'Email address',
			'tel'=>'Phone Number',
			'contact'=>'Contact Method',
			'country'=>'Country',
			'other_country'=>'Other Country',
			'language'=>'Preferred Language',
			'comments'=>'Comments'
			);
			
			foreach($_POST as $field=>$value)
			{
				if($field == 'firstname' || $field == 'surname' || $field == 'email' || $field == 'tel'  || $field == 'comments')
				{
					if(empty($_POST[$field]))
					{
						$blanks[$field] = "blank";
					}
				}  else if($field == 'country' && $value == 'none')
				{
					if($_POST['other_country'] == "")
					{
						$blanks[$field] = "blank";
					}
				}else if($field == 'language' && $value == 'none')
				{
					$blanks[$field] = "blank";
				} 
			}
			
			if(!empty($blanks))
			{
				if(sizeof($blanks)>0)
				{
					$message .= "<p class=\"red\">ONE OR MORE OF THE REQUIRED FIELDS ARE BLANK.<br/>Please enter the following information:<br>";
					foreach ($blanks as $field => $value)
					{
						$message .= "&nbsp;&nbsp;&nbsp;{$labels[$field]}<br/>";
					}
					$message .= "</p>";
				}
			} else
			{	
				// Create client, new enquiry & ref
				$client = new Client();
				$client->firstname 					= $firstname;
				$client->surname 					= $surname;
				$client->countries_id				= $country;
				$client->languages_id				= $language;
				$client->tel 						= $tel;
				$client->email 						= $email;
				$client->communication_methods_id 	= $contact;
				$client->establishments_id			= "";
				if($client->create())
				{
					$enquiry = new Enquiry();
					$maxid = get_max_id('enquiries');
					$enquiry->reference				= ($maxid +1001).'W';
					$enquiry->created				= date('Y-m-d h:i:s', time());
					$enquiry->no_people				= "";
					$enquiry->status 				= 1; 
					$enquiry->clients_id 			= $client->id;
					$enquiry->enquiry_methods_id 	= 1;
					$enquiry->coordinators_id		= 1;
					$enquiry->create();
					
					// Add Enquiries status 
					{
						$enquiries_status = new EnquiryStatus();
						$enquiries_status->enquiries_id = $enquiry->id;
						$enquiries_status->status_id = 1;
						$enquiries_status->create();
					}
				}
				
				// Get all text info for email
				$cm = CommunicationMethod::find_by_id($contact);
				$l = Language::find_by_id($language);
				$c = Country::find_by_id($country);
				
				$emessage = '<b>CLIENT DETAILS</b><br/>';
				$emessage .= '<table style=" font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;" cellpadding="5">';
				$emessage .= '<tr><td>NAME: </td><td>'.$firstname.' '.$surname.'</td></tr>';
				$emessage .= '<tr><td>EMAIL ADDRESS: </td><td>'.$email.'</td></tr>';
				$emessage .= '<tr><td>PHONE NUMBER: </td><td>'.$tel.'</td></tr>';
				$emessage .= '<tr><td>PREFERRED CONTACT METHOD: </td><td>'.$cm->name.'</td></tr>';
				$emessage .= '<tr><td>LANGUAGE: </td><td>'.$l->language.'</td></tr>';
				$emessage .= '<tr><td>COUNTRY OF ORIGIN: </td><td>'.$c->country.'</td></tr>';
				$emessage .= '</table><br/>';
				
				if($comments != '')
				{
					$emessage .= 'COMMENTS: <br/><br/>'.$comments.'<br/>';
					$note = new Note();
					$note->details = $comments;
					$note->users_id = 0;
					$note->create();
					
					$enq_note = new EnquiryNote();
					$enq_note->notes_id = $note->id;
					$enq_note->enquiries_id = $enquiry->id;
					$enq_note->create();
				}
				
				// send email								
				$to 		= "info@freshweb.co.za";
				$subject	= $enquiry->reference." - Website General Enquiry";
				$headers	= "From: ".$email."\r\n";
				$headers	.= "Reply-To: ".$email."\r\n";
			//	$headers	.= "CC: fleur@freshweb.co.za\r\n";
				$headers	.= "MIM-Version: 1.0\r\n";
				$headers	.= "Content-Type: text/html; charset=ISO-8859-1\r\n";
				
				$email_body	= '<html><body style="font-family:Arial, Helvetica, sans-serif; color:#555; font-size:10pt;">';
				$email_body .= '<h1>'.$enquiry->reference.'</h1>';
				$email_body	.= $emessage;
				$email_body	.= '</body></html>';
				
				$mailsend = mail($to, $subject, $email_body, $headers);
				
				redirect_to('enquiry-success.php');
			}
		}
	} else
	{
		$firstname 		= "";
		$surname 		= "";
		$country		= "";
		$other_country 	= "";
		$email 			= "";
		$tel 			= "";
		$contact 		= "1";
		$language		= "";
		$comments		= "";
	}
?>
<?php include_layout('html.php'); ?>

		<script type="text/javascript" language="JavaScript">
			function toggleLayer( whichLayer )
			{
			var elem, vis;
			if( document.getElementById ) // this is the way the standards work
			elem = document.getElementById( whichLayer );
			else if( document.all ) // this is the way old msie versions work
			elem = document.all[whichLayer];
			else if( document.layers ) // this is the way nn4 works
			elem = document.layers[whichLayer];
			vis = elem.style;
			// if the style.display value is blank we try to figure it out here
			if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
			vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';
			vis.display = (vis.display==''||vis.display=='block')?'none':'block';
			} 
		</script>
		
<?php include('./tour-guides-cape-town-layout/header.php'); ?>

			<div id="double"> 
				
				<div class="left">
				
					<div id="left_content">
						
						<h1>GENERAL ENQUIRY</h1>
						
						<?php if(isset($message) && $message != "") echo $message; ?>
						
						<form action="/general-enquiry.php" method="post">
							<div class="row">
								<div class="label">
									<label>First Name:</label>
								</div>
								<input name="firstname" size="30" value="<?php echo $firstname; ?>" />
							</div>
							
							<div class="row">
								<div class="label">
									<label>Surname:</label>
								</div>
								<input name="surname" size="30" value="<?php echo $surname; ?>" />
							</div>
							
							<div class="row">
								<div class="label">
									<label>Country of Origin:</label>
								</div>
								<select name="country">
									<option value="none" >Please select...</option>
									<?php 
										$countrs = Country::find_all();
										foreach($countrs as $countr)
										{
											echo '<option value="'.$countr->id;
											if($country == $countr->id) echo '" selected="selected';
											echo '">'.$countr->country.'</option>';
										}
									?>
								</select>
							</div>
							
							<div class="row">
								<div class="label">
									<label>If other, please specify:</label>
								</div>
								<input name="other_country" size="30" value="<?php echo $other_country; ?>" />
							</div>
							
							<div class="row">
								<div class="label">
									<label>Email address:</label>
								</div>
								<input type="text" name="email" size="30" value="<?php echo $email; ?>" />
							</div>
							
							<div class="row">
								<div class="label">
									<label>Phone Number:</label>
								</div>
								<input type="text" name="tel" size="30" value="<?php echo $tel; ?>" />
							</div>
							
							<div class="row">
								<div class="label">
									<label>Contact preference:</label>
								</div>
								<input type="radio" name="contact" value="1" <?php if($contact == 1) echo 'checked="checked"'; ?> /> <label>Email</label>&nbsp;&nbsp;&nbsp;&nbsp;
								<input type="radio" name="contact" value="3" <?php if($contact == 3) echo 'checked="checked"'; ?>/> <label>SMS</label>&nbsp;&nbsp;&nbsp;&nbsp;
								<input type="radio" name="contact" value="2" <?php if($contact == 2) echo 'checked="checked"'; ?>/> <label>Phone</label>
							</div>
							
							<div class="row">
								<div class="label">
									<label>Preferred Language:</label>
								</div>
								<select name="language">
									<option value="none">Please select...</option>
									<?php 
										$langs = Language::find_all();
										foreach($langs as $lang)
										{
											echo '<option value="'.$lang->id;
											if($language == $lang->id) echo '" selected="selected';
											echo '">'.$lang->language.'</option>';
										}
									?>
								</select>
							</div>	
							
							<div class="row">
								<div class="label">
									<label>Comments:</label>
								</div>
								<textarea name="comments" cols="50" rows="5" ><?php echo $comments; ?></textarea>
							</div>				
							
							<div class="row">
							<br/>
								<input type="submit" name="submit" value="Send Enquiry" />&nbsp;&nbsp;<input type="reset" name="reset" value="Reset" />
								<br/><br/>
							</div>
						</form>
					
					</div>
				</div>
				
				<?php include_layout('right-menu.php'); ?>
				
				<img src="/ctgc/tourism-south-africa/cape-tours-2-bott.gif" width="1005px" height="1px" />
			</div>
			
<?php include_layout('footer.php'); ?>
