<?php 
require_once(LIB_PATH.DS.'cape-guided-tours-database.php');

class Enquiry
{
	protected static $table_name="enquiries";
	protected static $db_fields = array('id', 'reference', 'created', 'no_people', 'status', 'total_cost', 'deposit', 'due_now', 'coordinators_id', 'clients_id', 'tours_id', 'enquiry_methods_id');
	public $id;
	public $reference;
	public $created;
	public $no_people;
	public $status;
	public $total_cost;
	public $deposit;
	public $due_now;
	public $coordinators_id;
	public $clients_id;
	public $tours_id;
	public $enquiry_methods_id;
	
	public $maxid;
	public $payments_total;
	
//	 Common Database Methods	
	public static function find_all()
	{
		return self::find_by_sql("SELECT * FROM ".self::$table_name." ORDER BY created");
	}
	
	public static function find_by_id($id=0)
	{
		global $database;
		$result_array = self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE id={$id} LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	public static function find_by_reference($ref=0)
	{
		global $database;
		$result_array = self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE reference='{$ref}' LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	public static function find_by_conditions($conditions="")
	{
		global $database;
		return self::find_by_sql("SELECT e.* FROM ".self::$table_name." e INNER JOIN tours t ON t.id=e.tours_id INNER JOIN services s ON s.id=t.services_id {$conditions}");
	}

	
//	public static function find_by_month()
//	{
//		global $database;
//		return self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE MONTH(created) = MONTH(CURRENT_DATE)");
//	}
	
//	public static function find_three_month()
//	{
//		global $database;
//		return self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE MONTH(created) = MONTH(CURRENT_DATE) OR MONTH(created) = (MONTH(CURRENT_DATE)-1) OR MONTH(created) = (MONTH(CURRENT_DATE)-2)");
//	}
	
//	public static function find_by_year()
//	{
//		global $database;
//		return self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE YEAR(created) = YEAR(CURRENT_DATE)");
//	}
	
//	public static function find_by_period($start="", $end="")
//	{
//		global $database;
//		return self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE created > ".$start." AND created < ".$end);
//	}
	
	public static function find_by_tour($tour)
	{
		global $database;
		return self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE tours_id = ".$tour);
	}
	
	public static function search($name="")
	{
		global $database;
		return self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE name LIKE %'{$name}'%");
	}
	
	public static function enquiry_payment_total()
	{
		global $database;
		$sql = "SELECT SUM(amount) ";
		$sql .= " FROM payments ";
		$sql .= " WHERE enquiries_ref='".$this->reference;
		$sql .= "' GROUP BY enquiries_ref";
		
		$this->payments_total = self::find_by_sql($sql);
		return $this->payments_total;
	}
	
	public static function find_by_sql($sql="")
	{
		global $database;
		$result_set = $database->query($sql);
		$object_array = array();
		while ($row = $database->fetch_array($result_set))
		{
			$object_array[] = self::instantiate($row);
		}
		return $object_array;
	
	}
	
	private static function instantiate($record)
	{
		// could check that $record exists and is an array
		$object = new self;
		
		foreach($record as $attribute=>$value)
		{
			if($object->has_attribute($attribute))
			{
				$object->$attribute = $value;
			}
		}
		return $object;		
	}
	
	private function has_attribute($attribute)
	{
		$object_vars = $this->attributes();
		return array_key_exists($attribute, $object_vars);
	}

	protected function attributes()
	{  	// return an array of attribute keys and their values
		$attributes = array();
		foreach(self::$db_fields as $field)
		{
			if(property_exists($this, $field))
			{
				$attributes[$field] = $this->$field; // use dynamic $field
			}
		}
		return $attributes;
	}
	
	protected function sanitized_attributes()
	{
		global $database;
		$clean_attributes = array();
		foreach($this->attributes() as $key => $value)
		{
			$clean_attributes[$key] = $database->escape_value($value);
		}
		return $clean_attributes;
	}
	
	public function create()
	{
		global $database;
		$attributes = $this->sanitized_attributes();
		
		$sql  = "INSERT INTO ".self::$table_name." (";
		$sql .= join(", ", array_keys($attributes));
		$sql .= ") VALUES ('";
		$sql .= join("', '", array_values($attributes));
		$sql .= "')";
		
		if($database->query($sql))
		{
			$this->id = $database->insert_id();
			return true;
		} else
		{
			return false;
		}
	}
	
	public function update()
	{
		global $database;
		$attributes = $this->sanitized_attributes();
		$attribute_pairs = array();
		foreach ($attributes as $key => $value)
		{
			$attribute_pairs[] = "{$key}='{$value}'";
		}
		
		$sql  = "UPDATE ".self::$table_name." SET ";
		$sql .= join(", ", $attribute_pairs);
		$sql .= " WHERE id=".$database->escape_value($this->id); //dont have to escape id, but no harm
		$database->query($sql);
		return($database->affected_rows() == 1) ? true : false;
	}
	
	public function delete()
	{
		global $database;
		$sql  = "DELETE FROM ".self::$table_name;
		$sql .= " WHERE id=".$database->escape_value($this->id);
		$sql .= " LIMIT 1";
		$database->query($sql);
		return ($database->affected_rows() == 1) ? true : false;
	}

}

class EnquiryStatus
{
	protected static $table_name="enquiries_status";
	protected static $db_fields = array('enquiries_id', 'status_id', 'timestamp');
	public $enquiries_id;
	public $status_id;
	public $timestamp;
	
//	 Common Database Methods	
	public static function find_all()
	{
		return self::find_by_sql("SELECT * FROM ".self::$table_name." ORDER BY timestamp");
	}
	
	public static function find_by_enquiry($enquiry=0)
	{
		global $database;
		return self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE enquiries_id={$enquiry} ORDER BY timestamp");
	}
	
	public static function find_by_status($status=0)
	{
		global $database;
		return self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE status_id={$status} ORDER BY timestamp");
	}
	
	public static function find_by_sql($sql="")
	{
		global $database;
		$result_set = $database->query($sql);
		$object_array = array();
		while ($row = $database->fetch_array($result_set))
		{
			$object_array[] = self::instantiate($row);
		}
		return $object_array;
	
	}
	
	private static function instantiate($record)
	{
		// could check that $record exists and is an array
		$object = new self;
		
		foreach($record as $attribute=>$value)
		{
			if($object->has_attribute($attribute))
			{
				$object->$attribute = $value;
			}
		}
		return $object;		
	}
	
	private function has_attribute($attribute)
	{
		$object_vars = $this->attributes();
		return array_key_exists($attribute, $object_vars);
	}

	protected function attributes()
	{  	// return an array of attribute keys and their values
		$attributes = array();
		foreach(self::$db_fields as $field)
		{
			if(property_exists($this, $field))
			{
				$attributes[$field] = $this->$field; // use dynamic $field
			}
		}
		return $attributes;
	}
	
	protected function sanitized_attributes()
	{
		global $database;
		$clean_attributes = array();
		foreach($this->attributes() as $key => $value)
		{
			$clean_attributes[$key] = $database->escape_value($value);
		}
		return $clean_attributes;
	}
	
	public function create()
	{
		global $database;
		$attributes = $this->sanitized_attributes();
		
		$sql  = "INSERT INTO ".self::$table_name." (";
		$sql .= join(", ", array_keys($attributes));
		$sql .= ") VALUES ('";
		$sql .= join("', '", array_values($attributes));
		$sql .= "')";
		
		if($database->query($sql))
		{
			$this->id = $database->insert_id();
			return true;
		} else
		{
			return false;
		}
	}
	
	public function update()
	{
		global $database;
		$attributes = $this->sanitized_attributes();
		$attribute_pairs = array();
		foreach ($attributes as $key => $value)
		{
			$attribute_pairs[] = "{$key}='{$value}'";
		}
		
		$sql  = "UPDATE ".self::$table_name." SET ";
		$sql .= join(", ", $attribute_pairs);
		$sql .= " WHERE id=".$database->escape_value($this->id); //dont have to escape id, but no harm
		$database->query($sql);
		return($database->affected_rows() == 1) ? true : false;
	}
	
	public function delete()
	{
		global $database;
		$sql  = "DELETE FROM ".self::$table_name;
		$sql .= " WHERE id=".$database->escape_value($this->id);
		$sql .= " LIMIT 1";
		$database->query($sql);
		return ($database->affected_rows() == 1) ? true : false;
	}

}

?>