<?php 
require_once(LIB_PATH.DS.'cape-guided-tours-database.php');

class Guide
{
	protected static $table_name="guides";
	protected static $db_fields = array('id', 'firstname', 'surname', 'badge_number', 'badge_expiry', 'gender', 'id_number', 'email', 'cellphone', 'suburbs_id', 'started_guiding', 'kin_name', 'kin_contact', 'kin_relationships_id', 'bank_branches_id', 'account_holder', 'account_types_id', 'bank_account', 'countries_id', 'communication_methods_id', 'comments', 'updated');
	public $id;
	public $firstname;
	public $surname;
	public $badge_number;
	public $badge_expiry;
	public $gender;
	public $id_number;
	public $email;
	public $cellphone;
	public $suburbs_id;
	public $started_guiding;
	public $kin_name;
	public $kin_contact;
	public $kin_relationships_id;
	public $bank_branches_id;
	public $account_holder;
	public $account_types_id;
	public $bank_account;
	public $countries_id;
	public $communication_methods_id;
	public $comments;
	public $updated;
	
//	 Common Database Methods	
	public static function find_all($order='surname, firstname')
	{
		return self::find_by_sql("SELECT * FROM ".self::$table_name." ORDER BY ".$order);
	}
	
	public static function find_by_id($id=0)
	{
		global $database;
		$result_array = self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE id={$id} LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	public static function find_guides_by_search($string="")
	{
		global $database;
		return self::find_by_sql("SELECT DISTINCT g.id, g.* FROM ".self::$table_name.' g '.$string);
	}
	
	public static function find_by_name($firstname="", $surname="")
	{
		global $database;
		$sql = "SELECT * FROM ".self::$table_name;
		if($firstname == "") $sql .= " WHERE surname LIKE '%{$surname}%'";
		elseif($surname == "") $sql .= " WHERE firstname LIKE '%{$firstname}%'";
		else $sql .= " WHERE firstname LIKE '%{$firstname}%' OR surname LIKE '%{$surname}%'";
		return self::find_by_sql($sql);
	}
	
	public static function find_for_tour($tour=0)
	{
		global $database;
		$sql = 'SELECT DISTINCT g.id, g.* FROM guides g ';
		$sql .= 'INNER JOIN v_services_guides vsg ON vsg.guides_id=g.id ';
		$sql .= 'INNER JOIN tours t ON t.services_id=vsg.services_id ';
		$sql .= 'INNER JOIN guides_languages gl ON gl.languages_id = t.languages_id ';
		$sql .= 'INNER JOIN vehicles v ON v.guides_id=g.id AND v.capacity >= t.capacity ';
		$sql .= 'WHERE g.id NOT IN (';
		$sql .= 'SELECT bd.guides_id FROM busy_days bd WHERE bd.date IN (SELECT date FROM busy_days WHERE tours_id='.$tour.')) ';
		$sql .= 'AND t.id='.$tour;
		
		return self::find_by_sql($sql);
	}
	
	public static function find_for_tour_only($tour=0)
	{
		global $database;
		$sql = 'SELECT DISTINCT g.id, g.* FROM guides g ';
		$sql .= 'INNER JOIN v_services_guides vsg ON vsg.guides_id=g.id ';
		$sql .= 'INNER JOIN tours t ON t.services_id=vsg.services_id ';
		$sql .= 'INNER JOIN guides_languages gl ON gl.languages_id = t.languages_id ';
		$sql .= 'WHERE g.id NOT IN (';
		$sql .= 'SELECT bd.guides_id FROM busy_days bd WHERE bd.date IN (SELECT date FROM busy_days WHERE tours_id='.$tour.')) ';
		$sql .= 'AND t.id='.$tour;
		
		return self::find_by_sql($sql);
	}
	
	public static function find_for_service($service = 0)
	{
		global $database;
		$sql = 'SELECT g.* FROM guides g ';
		$sql .= 'INNER JOIN v_services_guides vsg ON vsg.guides_id=g.id ';
		$sql .= 'AND vsg.services_id='.$service;
		$sql .= ' ORDER BY RAND()';
		
		return self::find_by_sql($sql);
	}
	
	public static function find_by_sql($sql="")
	{
		global $database;
		$result_set = $database->query($sql);
		$object_array = array();
		while ($row = $database->fetch_array($result_set))
		{
			$object_array[] = self::instantiate($row);
		}
		return $object_array;
	
	}
	
	private static function instantiate($record)
	{
		// could check that $record exists and is an array
		$object = new self;
		
		foreach($record as $attribute=>$value)
		{
			if($object->has_attribute($attribute))
			{
				$object->$attribute = $value;
			}
		}
		return $object;		
	}
	
	private function has_attribute($attribute)
	{
		$object_vars = $this->attributes();
		return array_key_exists($attribute, $object_vars);
	}

	protected function attributes()
	{  	// return an array of attribute keys and their values
		$attributes = array();
		foreach(self::$db_fields as $field)
		{
			if(property_exists($this, $field))
			{
				$attributes[$field] = $this->$field; // use dynamic $field
			}
		}
		return $attributes;
	}
	
	protected function sanitized_attributes()
	{
		global $database;
		$clean_attributes = array();
		foreach($this->attributes() as $key => $value)
		{
			$clean_attributes[$key] = $database->escape_value($value);
		}
		return $clean_attributes;
	}
	
	public function create()
	{
		global $database;
		$attributes = $this->sanitized_attributes();
		
		$sql  = "INSERT INTO ".self::$table_name." (";
		$sql .= join(", ", array_keys($attributes));
		$sql .= ") VALUES ('";
		$sql .= join("', '", array_values($attributes));
		$sql .= "')";
		
		if($database->query($sql))
		{
			$this->id = $database->insert_id();
			return true;
		} else
		{
			return false;
		}
	}
	
	public function update()
	{
		global $database;
		$attributes = $this->sanitized_attributes();
		$attribute_pairs = array();
		foreach ($attributes as $key => $value)
		{
			$attribute_pairs[] = "{$key}='{$value}'";
		}
		
		$sql  = "UPDATE ".self::$table_name." SET ";
		$sql .= join(", ", $attribute_pairs);
		$sql .= " WHERE id=".$database->escape_value($this->id); //dont have to escape id, but no harm
		$database->query($sql);
		return($database->affected_rows() == 1) ? true : false;
	}
	
	public function delete()
	{
		global $database;
		$sql  = "DELETE FROM ".self::$table_name;
		$sql .= " WHERE id=".$database->escape_value($this->id);
		$sql .= " LIMIT 1";
		$database->query($sql);
		return ($database->affected_rows() == 1) ? true : false;
	}

}

?>