<?php 
require_once(LIB_PATH.DS.'cape-guided-tours-database.php');

class User
{
	protected static $table_name="users";
	protected static $db_fields = array('id', 'coordinators_id', 'username', 'password', 'level');
	public $id;
	public $coordinators_id;
	public $username; //email
	public $password;
	public $level;
	
	public $new_password;
	
	public static function authenticate($username="", $password="")
	{
		global $database;
		$username = $database->escape_value($username);
		$password = $database->escape_value($password);
		$shapass  = sha1($password);
		
		$sql  = "SELECT * FROM users ";
		$sql .=	"WHERE username = '{$username}' ";
		$sql .=	"AND password = '{$shapass}'";
		$sql .=	" LIMIT 1";
				
		$result_array = self::find_by_sql($sql);
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	// Common Database Methods	
//	public static function find_all()
//	{
//		return self::find_by_sql("SELECT * FROM ".self::$table_name);
//	}
	
	public static function find_by_id($id=0)
	{
		global $database;
		$result_array = self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE id={$id} LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	public static function find_by_coordinator($id=0)
	{
		global $database;
		$result_array = self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE id={$id} LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	public static function find_by_username($username="")
	{
		global $database;
		$result_array = self::find_by_sql("SELECT * FROM ".self::$table_name." WHERE username = '{$username}' LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	public static function find_by_sql($sql="")
	{
		global $database;
		$result_set = $database->query($sql);
		$object_array = array();
		while ($row = $database->fetch_array($result_set))
		{
			$object_array[] = self::instantiate($row);
		}
		return $object_array;
	
	}
	
	private static function instantiate($record)
	{
		// could check that $record exists and is an array
		$object = new self;
		
		foreach($record as $attribute=>$value)
		{
			if($object->has_attribute($attribute))
			{
				$object->$attribute = $value;
			}
		}
		return $object;		
	}
	
	private function has_attribute($attribute)
	{
		$object_vars = $this->attributes();
		return array_key_exists($attribute, $object_vars);
	}

	protected function attributes()
	{  	// return an array of attribute keys and their values
		$attributes = array();
		foreach(self::$db_fields as $field)
		{
			if(property_exists($this, $field))
			{
				$attributes[$field] = $this->$field; // use dynamic $field
			}
		}
		return $attributes;
	}
	
	protected function sanitized_attributes()
	{
		global $database;
		$clean_attributes = array();
		foreach($this->attributes() as $key => $value)
		{
			$clean_attributes[$key] = $database->escape_value($value);
		}
		return $clean_attributes;
	}
	
	public function create()
	{
		global $database;
		$attributes = $this->sanitized_attributes();
		
		$sql  = "INSERT INTO ".self::$table_name." (";
		$sql .= join(", ", array_keys($attributes));
		$sql .= ") VALUES ('";
		$sql .= join("', '", array_values($attributes));
		$sql .= "')";
		
		if($database->query($sql))
		{
			$this->id = $database->insert_id();
			return true;
		} else
		{
			return false;
		}
	}
	
	public function update()
	{
		global $database;
		$this->password = sha1($this->new_password);
		
		$attributes = $this->sanitized_attributes();
		$attribute_pairs = array();
		foreach ($attributes as $key => $value)
		{
			$attribute_pairs[] = "{$key}='{$value}'";
		}
		
		$sql  = "UPDATE ".self::$table_name." SET ";
		$sql .= join(", ", $attribute_pairs);
		$sql .= " WHERE id=".$database->escape_value($this->id); //dont have to escape id, but no harm
		$database->query($sql);
		return($database->affected_rows() == 1) ? true : false;
	}
	
	public function delete()
	{
		global $database;
		$sql  = "DELETE FROM ".self::$table_name;
		$sql .= " WHERE id=".$database->escape_value($this->id);
		$sql .= " LIMIT 1";
		$database->query($sql);
		return ($database->affected_rows() == 1) ? true : false;
	}
	
	public function generate_password()
	{
		$chars = "234567890abcdefghijkmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ";
		$password = "";
		for($i = 1; $i <= 10; $i++)
		{
			$password .= $chars[mt_rand(0,strlen($chars))];
		}
		$this->new_password = $password;
		
		if($this->send_password())
		{
			$this->update();
		}
	}
	
	public function send_password()
	{
		$to = $this->username;
		$subject = 'Cape Tourist Guide Password Has Been Reset';
		
		$message = 'A new password has been requested for your Cape Tourist Guide account./n/n The password is ';
		$message .= $this->new_password;
		$message .= '/n/n <a href="http://www.capetouristguide.co.za/admin/login.php">Login</a> to change your password.';
		
		$header		= "From: info@capetouristguide.co.za\n";
		$header	   .= "Reply-To: info@capetouristguide.co.za\n";
		if($mailsend 	= mail($to, $subject, $message, $header))
		{
			return true;
		} else
		{
			return false;
		}
	}
}

?>