<?php

// dmx_options.php
// -------------------------------------------------------------------------------------------------
// The XComponents Options File: Set dealer ID
// and - optionally - the location of the templates and
// graphics used by XComponents, and a variety of behaviour flags controlling
// infotext display, debugging, etc...
//
// Project    > dmABS
// Revision   > $Rev: 160 $
// Date		  > $Date: 2009-12-08 13:00:05 +0000 (Tue, 08 Dec 2009) $
// Author     > RAK for DML
// Copyright  > (C) Digital Mail Limited (2005-2009)
// -------------------------------------------------------------------------------------------------

// Set dealer ID
// This is used by XComponents, and will seed the TST dealer id,
// overrideing any ID specified in the TST options file (dmb1_options.js)
$dmx_options['dealer_id'] = '9222';

// Use DHTML infotext (boolean)
$dmx_options['use_infotext'] = 1;

// Set location of B0 graphics library directory (including trailing /)
// Change the following line if you want to customise the graphics that appear in XComponents
$dmx_options['glib'] = '/dmx/core/b0/images/sgm/';

// Set location of the B0 stylesheets (including trailing /)
$dmx_options['css'] = '/dmx/core/b0/css/';

// Set localtion of the templates directory using root addressing (must include trailing slash)
$dmx_options['templates'] = '/dmx/templates/';

// Set localtion of the 'my_templates' directory (for your own template designs)
// using root addressing (must include trailing slash)
$dmx_options['my_templates'] = '/dmx/my_templates/';

// General error messages
$dmx_options['err_msg']['comserr'] = 'The shopping server is currently unavailable. Please try again later.'; // Show when the dmShop server cannot be contacted at all

// Use POST flag (boolean)
// Set to 1 to use POST requests to communicate with the DM protocol server, 0 to use GETS
$dmx_options['use_post'] = true;

// Set the preferred session propagation mechanism
// Using TST is the default
// Valid values include 'TST', 'cookie', 'PHP', 'ob_link_rewriting' (but 'ob_link_rewriting' is not yet implemented)
$dmx_options['session_mech'] = 'TST';

// GOOGLE ANALYTICS RELATED OPTIONS
// -------------------------------------------------------------------------------------------------
// Set Goggle Analytics account number
// If this is set to 'OFF' the site will not use Google Analytics
$dmx_options['ganal']['accno'] = 'OFF'; // ( in dmABS installations, the setting in abs_options.php will override this )

// Send Google Analytics transaction report (on redirect to dmAccount)
$dmx_options['ganal']['send_trans_rep'] = true;

// Tester IP addresses - don't send data to Google if accessing the site from one of these IP addresses
// These strings are POSIX regular expressions (so we can specify IP ranges)
// See: http://en.wikipedia.org/wiki/Regular_expression#POSIX
// Examples:
// $dmx_options['ganal']['tester_ip'][] = '140\.151\.120\.54';
// $dmx_options['ganal']['tester_ip'][] = '155\.120\.88\..+';
$dmx_options['ganal']['tester_ip'][] = '192\.168\.1\.[0-9]+';
$dmx_options['ganal']['tester_ip'][] = '217\.146\.125\.145';
$dmx_options['ganal']['tester_ip'][] = '87\.194\.35\.197';

// WEBCHAT RELATED OPTIONS
// -------------------------------------------------------------------------------------------------
// Address of chat server (without 'http://' prefix)
$dmx_options['chatserver'] = 'chat1.dmclub.net';

// -------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------
// FOR DEVELOPMENT ONLY: DO NOT CHANGE ANY OF THE FOLLOWING OPTIONS
// -------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------

// Version of dmx software
$dmx_version = '1.6.B.2-(GU)-svn160';

// PROTOCOL RELATED OPTIONS
//
// Protocol version
$dmx_protocol['dmshop']['prot_ver'] = 'r24s5'; // Version of protocol to use

// Protocol servers (add two or more)
//$dmx_protocol['dmshop']['server_urls'][] = 'http://dmshop1.edge2.dmclub.net/dmShop_r24s5/dmShop.cfm';
//$dmx_protocol['dmshop']['server_urls'][] = 'http://devweb.digitalmail.com/dmShop_r24s5/dmShop.cfm';
$dmx_protocol['dmshop']['server_urls'][] = 'http://dmshop1.dmclub.net/dmShop_r24s5/dmShop.cfm';
$dmx_protocol['dmshop']['server_urls'][] = 'http://dmshop2.dmclub.net/dmShop_r24s5/dmShop.cfm';

// Set the DOCTYPE for the DOCTYPE declaration
// (which is added if not already present at the top of a XComponents page)
$dmx_options['doctype'] = 'XHTML 1.0 Transitional';
// $dmx_options['doctype'] = 'XHTML 1.0 Strict';

// Location and version of XComponent panels
$dmx_options['panel']['root'] = '/dmx'; // Directory containing _PANELS/ (no trailing slash)
$dmx_options['panel']['version'] = 'english_1';

// Show debugging components, benchmarks, etc
// (0=Off, 1=Show General Debugging, 2=Show General Debugging and Intercept XComponent Powered Navigation)
$dmx_options['debug_level'] = 0;

// Place error reporting on its highest setting - BOOLEAN
// This affects both PHP and JavaScript error reporting
$dmx_options['error_rep'] = 0;

// Allow dealer identity seeding?
$dmx_options['seeding'] = false;

// Trolley Page URL (used as a landing page by AutoShop). If set to false don't jump to a new page.
$dmx_options['auto_trolley_url'] = '/numbers/ukgeo/checkout.php';

// -------------------------------------------------------------------------------------------------
// Default for NumberChoosers

$dmx_state_default = new stdClass;
$dmx_state_default->root 		= 'Public'; 
$dmx_state_default->range 		= 'ukgeo'; 
$dmx_state_default->service		= 'connect'; 
$dmx_state_default->plan 		= 'bas'; 
$dmx_state_default->gold 		= '0-999999'; 
$dmx_state_default->areacode 	= NULL; 
$dmx_state_default->areaname 	= NULL; 
$dmx_state_default->prefix	 	= '!44'; 

?>
